/**
 * AboutDialog.java is part of the main package 
 */
package reucd.gui;

/**
 * The list of imports used
 */

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import javax.swing.border.Border;
import javax.swing.BorderFactory;

/**
 * @author Mohamed
 * Created on Jan 25, 2004
 * AboutDialog.java is responsible for displaying a dialog that
 * contains REUCD features and instructions of use
 *
 */
public class AboutDialog extends JDialog implements ActionListener{

	/**creating the borders that will be used by the components
	 * in the tables
	 */
	Border etched = BorderFactory.createEtchedBorder();
	Border empty = BorderFactory.createEmptyBorder(5,5,20,5);
	Border compound = BorderFactory.createCompoundBorder(
	 				etched, empty);	
	
	/**The constructor builds a dialog with a configured Frame header 
	 * and a text area containing information of the programs features 
	 * and instructions of use
	 * @param frame
	 */
	public AboutDialog(JFrame frame)
			{	
				/**build up the frame*/
				super(frame, "About REUCD", true);
				Container cp= getContentPane();
			
				JPanel panel = new JPanel();
				setResizable(false);// cannot resize the dialog
				panel.setLayout(new GridLayout(1,1));
				JTextArea aboutArea = new JTextArea("\t\tWeclome to REUCD 1.0(c)\n\n" +
					"Features: \n\n"+
					"1) Some features \n\n" + 

					"How to use REUCD 1.0(c):\n\n" +
					"Some instructions",20,50);
					
				aboutArea.setWrapStyleWord(true);
				aboutArea.setLineWrap(true); //wrap the lines at the end of each word
				aboutArea.setEditable(false);//cannot edit information inside the dialog
				Font font = new Font("Arial",Font.BOLD,12);//setting the font
				aboutArea.setFont(font);
				aboutArea.setBorder(compound);//setting the border
				JScrollPane aboutScrollPane = new JScrollPane (aboutArea);//inserting the dialog
															//into a scroll pane
				panel.add(aboutScrollPane);
				JPanel panelOkButton = new JPanel();
				panelOkButton.setLayout(new FlowLayout());
				JButton ok = new JButton("OK"); //add the OK button
				ok.addActionListener(this);
				panelOkButton.add(ok);

				cp.add(panel, BorderLayout.CENTER);
				cp.add(panelOkButton, BorderLayout.SOUTH);
				/**set the tool kit text*/
				Toolkit t = getToolkit();
				Dimension dim = t.getScreenSize();
				setLocation(new Point(dim.width/6, dim.height/5));
				pack();
			}
			/**when the OK button is pressed, dispose the dialog*/
			public void actionPerformed(ActionEvent e) {
				this.dispose(); 
			}
}
