/**
 * Created on 2004-11-23
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

package reucd.gui;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.StringWriter;
import java.util.ArrayList;


import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.border.Border;

import org.apache.xerces.parsers.DOMParser;
import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import reucd.activityXML.*;
import reucd.main.Action;
import reucd.main.ActivityDiagram;
import reucd.main.ActivityEdge;
import reucd.main.ControlNode;
import reucd.main.REUCD;
import reucd.util.ExampleFileFilter;

class ActivityDiagramFrame extends JFrame implements ActionListener {		
	
	
	JTree activityDiagramTree ; 
	/**creating the borders that will be used by the components
	 * in the tables
	 */
	Border etched = BorderFactory.createEtchedBorder();
	Border empty = BorderFactory.createEmptyBorder(5,5,20,5);
	Border compound = BorderFactory.createCompoundBorder(
			etched, empty);
	
	REUCD importedFrame;
	ActivityDiagram importedActivityDiagram;
	ArrayList internalEdges = new ArrayList ();
	ArrayList actionXMLNodesList = new ArrayList();
	ArrayList terminalXMLNodesList = new ArrayList();
	ArrayList forkXMLNodesList = new ArrayList();
	ArrayList decisionXMLNodesList = new ArrayList();
	ArrayList controlXMLFlowsList = new ArrayList();
	
	String actionIdPrefix = "_10_5_abd02bc_1137223822000_533608_";
	String initialIdPrefix = "_10_5_abd02bc_1137223812828_877612_";
	String finalIdPrefix = "_10_5_abd02bc_1137223818750_812600_";
	String forkIdPrefix = "_10_5_abd02bc_1137223856312_56703_";
	String decisionIdPrefix = "_10_5_abd02bc_1137225980843_226342_";
	String controlFLowIdPrefix = "_10_5_abd02bc_1137223865843_254911_";
	String textBoxIdPrefix = "_10_5_abd02bc_1137223812843_73455_";
	String weightPrefixId = "_10_5_abd02bc_1137223865843_654517_";
	String guardPrefixId = "_10_5_abd02bc_1137395026000_938042_";
	
	String actionType = "uml:CallBehaviorAction";
	String finalType = "uml:ActivityFinalNode";
	String initialType = "uml:InitialNode";
	String forkType = "uml:ForkNode";
	String decisionType = "uml:DecisionNode";
	String controlFlowType = "uml:ControlFlow";
	String weightType = "uml:LiteralInteger";
	String guardType ="uml:OpaqueExpression";
	
	int textBoxCounter = 1; //textBox counter
	int weightCounter =  1;
	int guardCounter = 1;
	
	int layoutSeparator = 100;
	int seperationDistance = 65;
	
	/** xml document */
	private static Document doc = null;
	private Document nonStaticDoc = null;
	private static String   xmlStr = null;
	
	public ActivityDiagramFrame(REUCD frame, ActivityDiagram activityDiagram, ArrayList activityEdges)
	{	
		super("Diagram Name: " + activityDiagram.getName());
		Container cp= getContentPane();
		importedFrame = frame;
		importedActivityDiagram = activityDiagram;
		
		
		
		int i;
		for (i = 0; i < activityEdges.size(); i++){
			
			ActivityEdge currentActivityEdge = ((ActivityEdge)activityEdges.get(i));
			
			if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
				
				Action sourceAction = ((Action)currentActivityEdge.getSourceAction());
				
				if (equalActivityDiagrams(sourceAction.getOwningActivityDiagram(), activityDiagram)){
					if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
						Action destinationAction = ((Action)currentActivityEdge.getDestinationAction()); 
						if (equalActivityDiagrams(destinationAction.getOwningActivityDiagram(),activityDiagram)){
							internalEdges.add(currentActivityEdge);
						}
					}
					else if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
						ControlNode destinationControlNode = ((ControlNode)currentActivityEdge.getDestinationControlNode());
						if (equalActivityDiagrams(destinationControlNode.getOwningActivityDiagram(),activityDiagram)){
							internalEdges.add(currentActivityEdge);
						}
					}
				}
			}
			else if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
				
				ControlNode sourceControlNode = ((ControlNode)currentActivityEdge.getSourceControlNode());
				
				if (equalActivityDiagrams(sourceControlNode.getOwningActivityDiagram(), activityDiagram)){
					if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
						Action destinationAction = ((Action)currentActivityEdge.getDestinationAction());
						if (equalActivityDiagrams(destinationAction.getOwningActivityDiagram(),activityDiagram)){
							internalEdges.add(currentActivityEdge);
						}
					}
					else if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
						ControlNode destinationControlNode = ((ControlNode)currentActivityEdge.getDestinationControlNode());
						if (equalActivityDiagrams(destinationControlNode.getOwningActivityDiagram(),activityDiagram)){
							internalEdges.add(currentActivityEdge);
						}
					}
				}
			}
			
		}
		
		ActivityDiagramTree adtree = new ActivityDiagramTree();
		activityDiagramTree = adtree.createTree(internalEdges, activityDiagram);
		activityDiagramTree.setBackground(Color.WHITE);
		
		
		JScrollPane adTreePane = new JScrollPane();
		adTreePane.getViewport().add( activityDiagramTree );
		
		setResizable(true);
		this.setSize(300,400);
		
		JButton createXMLButton = new JButton("Create Activity XML File");
		createXMLButton.addActionListener(this);
		
		JButton close = new JButton("Close");
		close.addActionListener(this);
		
		
		
		JPanel buttonPane = new JPanel();
		buttonPane.setLayout(new BoxLayout(buttonPane, BoxLayout.LINE_AXIS));
		buttonPane.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
		buttonPane.add(Box.createHorizontalGlue());
		buttonPane.add(createXMLButton);
		buttonPane.add(Box.createRigidArea(new Dimension(10, 0)));
		buttonPane.add(close);
		
		cp.add(adTreePane, BorderLayout.CENTER);
		cp.add(buttonPane, BorderLayout.SOUTH);
		
		Toolkit t = getToolkit();
		Dimension dim = t.getScreenSize();
		setLocation(new Point(dim.width/3, dim.height/3));
		
	}
	
	private boolean equalActivityDiagrams(ActivityDiagram owningActivityDiagram, ActivityDiagram activityDiagram) {
		
		if (owningActivityDiagram.getName().
				equalsIgnoreCase(activityDiagram.getName())  &&
				owningActivityDiagram.getOwningUseCaseName().equalsIgnoreCase(activityDiagram.getOwningUseCaseName())) {
			return true;
		}
		return false;
	}
	
	public void actionPerformed(ActionEvent e) {
		
		if (e.getActionCommand().equalsIgnoreCase("Create Activity XML File")) {
			
			
			
			ArrayList actionNodesAccountedFor = new ArrayList();
			ArrayList controlNodesAccountedFor = new ArrayList();
			
			
			//filtering through all the edges to obtain all the action and control nods
			for (int i = 0 ; i < internalEdges.size(); i++){
				
				ActivityEdge currentActivityEdge = ((ActivityEdge)internalEdges.get(i));
				
				if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
					Action sourceAction = ((Action)currentActivityEdge.getSourceAction());
					if (!actionNodesAccountedFor.contains(sourceAction)){
						actionNodesAccountedFor.add(sourceAction);
					}
					
				}
				
				if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
					
					Action destinationAction = ((Action)currentActivityEdge.getDestinationAction());
					if (!actionNodesAccountedFor.contains(destinationAction)){
						actionNodesAccountedFor.add(destinationAction);
					}
				}
				
				if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
					
					ControlNode sourceControlNode = ((ControlNode)currentActivityEdge.getSourceControlNode());
					if (!controlNodesAccountedFor.contains(sourceControlNode)){
						controlNodesAccountedFor.add(sourceControlNode);
					}
				}
				if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
					
					ControlNode destinationControlNode = ((ControlNode)currentActivityEdge.getDestinationControlNode());
					if (!controlNodesAccountedFor.contains(destinationControlNode)){
						controlNodesAccountedFor.add(destinationControlNode);
					}
				}
				
			}

			
			for (int i = 0 ; i < actionNodesAccountedFor.size(); i++){
				
				ActionXMLNode newAction = new ActionXMLNode();
				Action currentAction = ((Action)actionNodesAccountedFor.get(i));
				
				newAction.setId(actionIdPrefix + currentAction.getActionID());
				newAction.setType(actionType);
				newAction.setName(getDescription(currentAction));
				newAction.setActionWrapperPrefixId(newAction.getActionWrapperPrefixId() + currentAction.getActionID());
				actionXMLNodesList.add(newAction);
				
			}
			
			for (int i = 0 ; i < controlNodesAccountedFor.size(); i++){
				
				ControlNode currentControlNode = ((ControlNode)controlNodesAccountedFor.get(i));
				
				if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_initial)){
					TerminalXMLNode newNode = new  TerminalXMLNode();
					
					newNode.setId(initialIdPrefix + currentControlNode.getControlID());
					newNode.setType(initialType);
					newNode.setIntialWrapperPrefixId(newNode.getIntialWrapperPrefixId()+ (currentControlNode.getControlID()+1));
					terminalXMLNodesList.add(newNode);
					
				}
				else if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_final)){
					TerminalXMLNode newNode = new  TerminalXMLNode();
					
					newNode.setId(finalIdPrefix + currentControlNode.getControlID());
					newNode.setType(finalType);
					newNode.setFinalWrapperPrefixId(newNode.getFinalWrapperPrefixId()+ (currentControlNode.getControlID()+1));
					terminalXMLNodesList.add(newNode);
					
				}
				else if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_fork)
						||currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_join)){
					ControlXMLNode newNode = new  ControlXMLNode();
					
					newNode.setId(forkIdPrefix + currentControlNode.getControlID());
					newNode.setType(forkType);
					newNode.setForkJoinWrapperPrefixId(newNode.getForkJoinWrapperPrefixId() + (currentControlNode.getControlID()+1));
					forkXMLNodesList.add(newNode);
				}
				else if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_decision)){
					ControlXMLNode newNode = new  ControlXMLNode();
					
					newNode.setId(decisionIdPrefix + currentControlNode.getControlID());
					newNode.setType(decisionType);
					newNode.setDecisionWrapperPrefixId(newNode.getDecisionWrapperPrefixId() + (currentControlNode.getControlID()+1));
					decisionXMLNodesList.add(newNode);
				}
			}
			
			
			//time to iterate through the edges to construct the xml type edge objects
			//and to fill up the other control and action nodes
			
			
			for (int i = 0 ; i < internalEdges.size(); i++){
				
				ActivityEdge currentActivityEdge = ((ActivityEdge)internalEdges.get(i)); 
				
				ControlXMLFlow newFlow = new ControlXMLFlow ();
				
				newFlow.setId(controlFLowIdPrefix  +i);
				newFlow.setType(controlFlowType);
				newFlow.setFlowWrapperPrefixedId(newFlow.getFlowWrapperPrefixedId() + (i+2));
				
				if (!currentActivityEdge.getIfStatement().equalsIgnoreCase("")){
					newFlow.setGaurd(currentActivityEdge.getIfStatement());
				}
				
				if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
					
					Action sourceAction = ((Action)currentActivityEdge.getSourceAction());
					
					ActionXMLNode sourceNode = getActionXMLNodeFromAction (sourceAction);
					sourceNode.setOutgoing(newFlow.getId());
					newFlow.setSource(sourceNode.getId());
				}
				
				if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
					
					Action destinationAction = ((Action)currentActivityEdge.getDestinationAction());
					
					ActionXMLNode destinationNode = getActionXMLNodeFromAction (destinationAction);
					destinationNode.setIncoming(newFlow.getId());
					newFlow.setTarget(destinationNode.getId());
				}
				
				//as a source, it can't be a final node
				if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
					
					
					
					ControlNode currentControlNode = ((ControlNode)currentActivityEdge.getSourceControlNode());
					
					if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_initial)){
						
						TerminalXMLNode newNode = getTerminalXMLNode (currentControlNode);
						newNode.setOutgoing(newFlow.getId());
						newFlow.setSource(newNode.getId());
						
					}
					else if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_fork)
							||currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_join)){
						
						ControlXMLNode newNode = getForkXMLNode(currentControlNode);
						newNode.getOutgoing().add(newFlow.getId());
						newFlow.setSource(newNode.getId());
						
						
					}
					else if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_decision)){
						
						ControlXMLNode newNode = getDecisionXMLNode(currentControlNode);
						newNode.getOutgoing().add(newFlow.getId());
						newFlow.setSource(newNode.getId());
						
					}
					
				}
				
				
				//as a target, it can't be an initial node
				if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
					
					ControlNode currentControlNode = ((ControlNode)currentActivityEdge.getDestinationControlNode());
					
					if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_final)){
						
						TerminalXMLNode newNode = getTerminalXMLNode (currentControlNode);
						newNode.setIncoming(newFlow.getId());
						newFlow.setTarget(newNode.getId());
						
					}
					else if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_fork)
							||currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_join)){
						
						ControlXMLNode newNode = getForkXMLNode(currentControlNode);
						newNode.getIncoming().add(newFlow.getId());
						newFlow.setTarget(newNode.getId());
						
					}
					else if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_decision)){
						
						ControlXMLNode newNode = getDecisionXMLNode(currentControlNode);
						newNode.getIncoming().add(newFlow.getId());
						newFlow.setTarget(newNode.getId());
						
					}
					
				}
				
				controlXMLFlowsList.add(newFlow);
				
			}
			
			
			File currentDir = new File("C:\\REUCD");
			
			JFileChooser chooser = new JFileChooser(currentDir);
			chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
			
			ExampleFileFilter filter = new ExampleFileFilter();
			filter.addExtension("xml");
			filter.setDescription("Activity XML File");
			chooser.setFileFilter(filter);
			chooser.setDialogTitle("Create Activity XML File");
			
			int returnVal = chooser.showOpenDialog(importedFrame);
			if(returnVal != JFileChooser.APPROVE_OPTION) {
				return;
			}
			
			String fileName = chooser.getSelectedFile().getPath();
			
			try 
			{  
				
				DOMParser parser = new DOMParser();	  
				parser.parse("Empty Activity.xml");
				doc = parser.getDocument();
				nonStaticDoc = doc;
				
			}catch (Exception e1) {	
				System.err.println("XML reading error: " + e1);
			}
			
			createActivityDiagram(nonStaticDoc);
			
			generateXMLString(nonStaticDoc);
			
			System.out.println("filename:" + fileName);
			
			if (!fileName.endsWith("xml")){
				fileName = fileName + ".xml";
			}
			
			try {
				
				BufferedWriter out = new BufferedWriter(new FileWriter(fileName));
				out.write(getXMLString());
				out.close();
			} catch (IOException e2) {
			}
			
			
			
		}
		else{
			this.dispose();
		}
	}
	
	private void createActivityDiagram(Node node) {
		
		int type = node.getNodeType();
		switch (type)
		{
		case Node.DOCUMENT_NODE: 
		{
			createActivityDiagram(((Document)node).getDocumentElement());
			break;
		}
		
		/**  element with attributes */
		case Node.ELEMENT_NODE: 
		{
			if (node.getNodeName().equalsIgnoreCase("ownedMember")) {
				
				NamedNodeMap attrs = node.getAttributes(); 
				Node attr = null;
				
				for (int i = 0; i < attrs.getLength(); i++)
				{
					attr = attrs.item(i);
					if (attr.getNodeName().equalsIgnoreCase("type")) {
						break;
					} 
				}
				
				String attrValue = attr.getNodeValue();
				
				if (attrValue.equalsIgnoreCase("uml:Activity")) { 
					//adding initial and final nodes
					for (int i = 0; i < terminalXMLNodesList.size(); i++){
						
						TerminalXMLNode newNode = ((TerminalXMLNode)terminalXMLNodesList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("node");
						
						if (newNode.getType().equalsIgnoreCase(initialType)){//its an initial node
							
							newElement.setAttribute("outgoing", newNode.getOutgoing());
							newElement.setAttribute("visibility","public");
							newElement.setAttribute("xmi:id", newNode.getId());
							newElement.setAttribute("xmi:type",initialType);
							
						}
						else{//its a final Node
							
							newElement.setAttribute("incoming", newNode.getIncoming());
							newElement.setAttribute("visibility","public");
							newElement.setAttribute("xmi:id", newNode.getId());
							newElement.setAttribute("xmi:type", finalType);
							
						}
						node.appendChild(newElement);
						
					}
					
					for (int i = 0; i < actionXMLNodesList.size(); i++){
						
						
						ActionXMLNode newNode = ((ActionXMLNode)actionXMLNodesList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("node");
						
						if (!newNode.getIncoming().equalsIgnoreCase("")){
							newElement.setAttribute("incoming", newNode.getIncoming());
						}
						
						if (!newNode.getOutgoing().equalsIgnoreCase("")){
							newElement.setAttribute("outgoing", newNode.getOutgoing());
						}
						
						newElement.setAttribute("visibility","public");
						newElement.setAttribute("name", newNode.getName());
						newElement.setAttribute("xmi:id", newNode.getId());
						newElement.setAttribute("xmi:type",actionType);
						
						node.appendChild(newElement);
					}
					
					for (int i = 0; i < forkXMLNodesList.size(); i++){
						
						
						ControlXMLNode newNode = ((ControlXMLNode)forkXMLNodesList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("node");
						
						
						for (int j = 0; j < newNode.getIncoming().size(); j++){
							
							newElement.setAttribute("incoming", (String)(newNode.getIncoming().get(j)));
							
						}
						
						for (int j = 0; j < newNode.getOutgoing().size(); j++){
							
							newElement.setAttribute("outgoing", (String)(newNode.getOutgoing().get(j)));
							
						}
						
						newElement.setAttribute("visibility","public");
						newElement.setAttribute("xmi:id", newNode.getId());
						newElement.setAttribute("xmi:type",newNode.getType());
						
						node.appendChild(newElement);
					}
					
					for (int i = 0; i < decisionXMLNodesList.size(); i++){
						
						
						ControlXMLNode newNode = ((ControlXMLNode)decisionXMLNodesList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("node");
						
						
						for (int j = 0; j < newNode.getIncoming().size(); j++){
							
							newElement.setAttribute("incoming", (String)(newNode.getIncoming().get(j)));
							
						}
						
						for (int j = 0; j < newNode.getOutgoing().size(); j++){
							
							newElement.setAttribute("outgoing", (String)(newNode.getOutgoing().get(j)));
							
						}
						
						newElement.setAttribute("visibility","public");
						newElement.setAttribute("xmi:id", newNode.getId());
						newElement.setAttribute("xmi:type",newNode.getType());
						
						node.appendChild(newElement);
					}
					
					
					
					for (int i = 0; i < controlXMLFlowsList.size(); i++){
						
						ControlXMLFlow newNode = ((ControlXMLFlow)controlXMLFlowsList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("edge");
						
						System.out.println("this is the type: " + newNode.getType());
						
						newElement.setAttribute("target", newNode.getTarget());
						newElement.setAttribute("source", newNode.getSource());
						newElement.setAttribute("visibility","public");
						newElement.setAttribute("xmi:id", newNode.getId());
						newElement.setAttribute("xmi:type",newNode.getType());
						
						Element weightElement;
						weightElement = (node.getOwnerDocument()).createElement("weight");
						
						weightElement.setAttribute("visibility","public");
						weightElement.setAttribute("value", "1");
						weightElement.setAttribute("xmi:id", weightPrefixId + weightCounter);
						weightElement.setAttribute("xmi:type",weightType);
						weightCounter++;
						
						if (!newNode.getGuard().equalsIgnoreCase("")){
							
							Element guardElement;
							guardElement = (node.getOwnerDocument()).createElement("guard");
							
							guardElement.setAttribute("xmi:type",guardType);
							guardElement.setAttribute("xmi:id", guardPrefixId + guardCounter);
							guardElement.setAttribute("visibility","public");
							guardElement.setAttribute("language","English");
							guardElement.setAttribute("body",newNode.getGuard());
							guardCounter++;
							
							newElement.appendChild(guardElement);
						}
						
						
						newElement.appendChild(weightElement);
						node.appendChild(newElement);
					}
					
				}
			}
			
			
			
			
			
			
			
			if (node.getNodeName().equalsIgnoreCase("mdOwnedViews")) {
				
				Node parnetNode = node.getParentNode();
				NamedNodeMap attrs = parnetNode.getAttributes(); 
				Node attr = null;
				
				for (int i = 0; i < attrs.getLength(); i++)
				{
					attr = attrs.item(i);
					if (attr.getNodeName().equalsIgnoreCase("elementClass")) {
						break;
					} 
				}
				
				
				String attrType = attr.getNodeValue();
				if ( attrType.equalsIgnoreCase("DiagramPresentationElement")){
					
					//adding initial and final Wrapper nodes
					
					for (int i = 0; i < actionXMLNodesList.size(); i++){
						
						
						ActionXMLNode newNode = ((ActionXMLNode)actionXMLNodesList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("mdElement");
						
						newElement.setAttribute("elementClass", "CallBehaviorAction");
						newElement.setAttribute("xmi:id", newNode.getActionWrapperPrefixId());
						
						Element elementIDElement;
						elementIDElement = (node.getOwnerDocument()).createElement("elementID");
						elementIDElement.setAttribute("xmi:idref", newNode.getId());
						newElement.appendChild(elementIDElement);
						
						
						Element geometryElement;
						geometryElement = (node.getOwnerDocument()).createElement("geometry");
						geometryElement.setTextContent("200," + layoutSeparator + ", 20, 20");
						layoutSeparator = layoutSeparator + seperationDistance;
						newElement.appendChild(geometryElement);
						
						node.appendChild(newElement);
					}
					
					for (int i = 0; i < forkXMLNodesList.size(); i++){
						
						
						ControlXMLNode newNode = ((ControlXMLNode)forkXMLNodesList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("mdElement");
						
						newElement.setAttribute("elementClass", "Bar");
						newElement.setAttribute("xmi:id", newNode.getForkJoinWrapperPrefixId());
						
						Element elementIDElement;
						elementIDElement = (node.getOwnerDocument()).createElement("elementID");
						elementIDElement.setAttribute("xmi:idref", newNode.getId());
						newElement.appendChild(elementIDElement);
						
						
						Element geometryElement;
						geometryElement = (node.getOwnerDocument()).createElement("geometry");
						geometryElement.setTextContent("200," + layoutSeparator + ", 100, 8");
						newElement.appendChild(geometryElement);
						
						Element mdOwnedViewsElement;
						mdOwnedViewsElement = (node.getOwnerDocument()).createElement("mdOwnedViews");
						newElement.appendChild(mdOwnedViewsElement);
						
						Element mdElement;
						mdElement = (node.getOwnerDocument()).createElement("mdElement");
						mdElement.setAttribute("xmi:id", textBoxIdPrefix +  textBoxCounter);
						mdElement.setAttribute("elementClass", "TextBox");
						mdOwnedViewsElement.appendChild(mdElement);
						
						Element geometryMdElement;
						geometryMdElement = (node.getOwnerDocument()).createElement("geometry");
						geometryMdElement.setTextContent("200," + layoutSeparator + ", 20, 20");
						layoutSeparator = layoutSeparator + seperationDistance;
						mdElement.appendChild(geometryMdElement);
						
						Element visibleElement;
						visibleElement = (node.getOwnerDocument()).createElement("visible");
						visibleElement.setAttribute("xmi:idref", "false");
						mdElement.appendChild(visibleElement);
						
						Element nameIDElement;
						nameIDElement = (node.getOwnerDocument()).createElement("nameID");
						nameIDElement.setAttribute("xmi:idref", textBoxIdPrefix +  textBoxCounter);
						newElement.appendChild(nameIDElement);
						
						
						Element typeHorizontalElement;
						typeHorizontalElement = (node.getOwnerDocument()).createElement("type");
						typeHorizontalElement.setTextContent("HORIZONTAL");
						newElement.appendChild(typeHorizontalElement);
						
						
						textBoxCounter++;
						
						node.appendChild(newElement);
					}
					
					for (int i = 0; i < decisionXMLNodesList.size(); i++){
						
						
						ControlXMLNode newNode = ((ControlXMLNode)decisionXMLNodesList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("mdElement");
						
						newElement.setAttribute("elementClass", "Decision");
						newElement.setAttribute("xmi:id", newNode.getDecisionWrapperPrefixId());
						
						Element elementIDElement;
						elementIDElement = (node.getOwnerDocument()).createElement("elementID");
						elementIDElement.setAttribute("xmi:idref", newNode.getId());
						newElement.appendChild(elementIDElement);
						
						
						Element geometryElement;
						geometryElement = (node.getOwnerDocument()).createElement("geometry");
						geometryElement.setTextContent("200," + layoutSeparator + ", 20, 20");
						newElement.appendChild(geometryElement);
						
						Element mdOwnedViewsElement;
						mdOwnedViewsElement = (node.getOwnerDocument()).createElement("mdOwnedViews");
						newElement.appendChild(mdOwnedViewsElement);
						
						Element mdElement;
						mdElement = (node.getOwnerDocument()).createElement("mdElement");
						mdElement.setAttribute("xmi:id", textBoxIdPrefix +  textBoxCounter);
						mdElement.setAttribute("elementClass", "TextBox");
						mdOwnedViewsElement.appendChild(mdElement);
						
						Element geometryMdElement;
						geometryMdElement = (node.getOwnerDocument()).createElement("geometry");
						geometryMdElement.setTextContent("200," + layoutSeparator + ", 20, 20");
						layoutSeparator = layoutSeparator + seperationDistance;
						mdElement.appendChild(geometryMdElement);
						
						Element visibleElement;
						visibleElement = (node.getOwnerDocument()).createElement("visible");
						visibleElement.setAttribute("xmi:idref", "false");
						mdElement.appendChild(visibleElement);
						
						Element nameIDElement;
						nameIDElement = (node.getOwnerDocument()).createElement("nameID");
						nameIDElement.setAttribute("xmi:idref", textBoxIdPrefix +  textBoxCounter);
						newElement.appendChild(nameIDElement);
						
						textBoxCounter++;
						
						node.appendChild(newElement);
					}
					
					
					for (int i = 0; i < controlXMLFlowsList.size(); i++){
						
						ControlXMLFlow newNode = ((ControlXMLFlow)controlXMLFlowsList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("mdElement");
						newElement.setAttribute("elementClass", "ControlFlow");
						newElement.setAttribute("xmi:id", newNode.getFlowWrapperPrefixedId());
						
						Element elementIDElement;
						elementIDElement = (node.getOwnerDocument()).createElement("elementID");
						elementIDElement.setAttribute("xmi:idref", newNode.getId());
						newElement.appendChild(elementIDElement);
						
						Element linkFirstEndIDElement;
						linkFirstEndIDElement = (node.getOwnerDocument()).createElement("linkFirstEndID");
						linkFirstEndIDElement.setAttribute("xmi:idref", getWrapper(newNode.getTarget()));
						newElement.appendChild(linkFirstEndIDElement);
						
						Element linkSecondEndIDElement;
						linkSecondEndIDElement = (node.getOwnerDocument()).createElement("linkSecondEndID");
						linkSecondEndIDElement.setAttribute("xmi:idref", getWrapper(newNode.getSource()));
						newElement.appendChild(linkSecondEndIDElement);
						
						Element geometryMdElement;
						geometryMdElement = (node.getOwnerDocument()).createElement("geometry");
						geometryMdElement.setTextContent("200, 100; 20, 20;");
						newElement.appendChild(geometryMdElement);
						
						Element nameIDElement;
						nameIDElement = (node.getOwnerDocument()).createElement("linkNameID");
						nameIDElement.setAttribute("xmi:idref", textBoxIdPrefix +  textBoxCounter);
						newElement.appendChild(nameIDElement);
						
						Element nameVisibleElement;
						nameVisibleElement = (node.getOwnerDocument()).createElement("nameVisible");
						nameVisibleElement.setAttribute("xmi:value", "true");
						newElement.appendChild(nameVisibleElement);
						
						Element mdOwnedViewsElement;
						mdOwnedViewsElement = (node.getOwnerDocument()).createElement("mdOwnedViews");
						newElement.appendChild(mdOwnedViewsElement);
						
						Element textBoxElement;
						textBoxElement = (node.getOwnerDocument()).createElement("mdElement");
						textBoxElement.setAttribute("xmi:id", textBoxIdPrefix +  textBoxCounter);
						textBoxElement.setAttribute("elementClass", "TextBox");
						mdOwnedViewsElement.appendChild(textBoxElement);
						
						Element geometryElement;
						geometryElement = (node.getOwnerDocument()).createElement("geometry");
						geometryElement.setTextContent("100, 100, 0, 0");
						textBoxElement.appendChild(geometryElement);
						
						if (!newNode.getGuard().equalsIgnoreCase("")){
							Element gaurdElement;
							gaurdElement = (node.getOwnerDocument()).createElement("text");
							gaurdElement.setTextContent("[" + newNode.getGuard() +"]");
							textBoxElement.appendChild(gaurdElement);
						}
						else{
							Element visibleElement;
							visibleElement = (node.getOwnerDocument()).createElement("visible");
							visibleElement.setAttribute("xmi:value", "false");
							textBoxElement.appendChild(visibleElement);
						}
						
						textBoxCounter++;
						
						Element textBoxElement2;
						textBoxElement2 = (node.getOwnerDocument()).createElement("mdElement");
						textBoxElement2.setAttribute("xmi:id", textBoxIdPrefix +  textBoxCounter);
						textBoxElement2.setAttribute("elementClass", "TextBox");
						mdOwnedViewsElement.appendChild(textBoxElement2);
						
						Element geometryElement2;
						geometryElement2 = (node.getOwnerDocument()).createElement("geometry");
						geometryElement2.setTextContent("200, 20, 20, 20");
						textBoxElement2.appendChild(geometryElement2);
						
						Element visibleElement2;
						visibleElement2 = (node.getOwnerDocument()).createElement("visible");
						visibleElement2.setAttribute("xmi:value", "false");
						textBoxElement2.appendChild(visibleElement2);
						
						Element editableElement2;
						editableElement2 = (node.getOwnerDocument()).createElement("editable");
						editableElement2.setAttribute("xmi:value", "false");
						textBoxElement2.appendChild(editableElement2);
						
						textBoxCounter++;
						
						Element textBoxElement3;
						textBoxElement3 = (node.getOwnerDocument()).createElement("mdElement");
						textBoxElement3.setAttribute("xmi:id", textBoxIdPrefix +  textBoxCounter);
						textBoxElement3.setAttribute("elementClass", "TextBoxWithIcon");
						mdOwnedViewsElement.appendChild(textBoxElement3);
						
						Element geometryElement3;
						geometryElement3 = (node.getOwnerDocument()).createElement("geometry");
						geometryElement3.setTextContent("200, 20, 20, 20");
						textBoxElement3.appendChild(geometryElement3);
						
						Element visibleElement3;
						visibleElement3 = (node.getOwnerDocument()).createElement("visible");
						visibleElement3.setAttribute("xmi:value", "false");
						textBoxElement3.appendChild(visibleElement3);
						
						Element editableElement3;
						editableElement3 = (node.getOwnerDocument()).createElement("editable");
						editableElement3.setAttribute("xmi:value", "false");
						textBoxElement3.appendChild(editableElement3);
						
						textBoxCounter++;
						
						Element textBoxElement4;
						textBoxElement4 = (node.getOwnerDocument()).createElement("mdElement");
						textBoxElement4.setAttribute("xmi:id", textBoxIdPrefix +  textBoxCounter);
						textBoxElement4.setAttribute("elementClass", "TextBox");
						mdOwnedViewsElement.appendChild(textBoxElement4);
						
						Element geometryElement4;
						geometryElement4 = (node.getOwnerDocument()).createElement("geometry");
						geometryElement4.setTextContent("200, 20, 20, 20");
						textBoxElement4.appendChild(geometryElement4);
						
						Element visibleElement4;
						visibleElement4 = (node.getOwnerDocument()).createElement("visible");
						visibleElement4.setAttribute("xmi:value", "false");
						textBoxElement4.appendChild(visibleElement4);
						
						Element editableElement4;
						editableElement4 = (node.getOwnerDocument()).createElement("editable");
						editableElement4.setAttribute("xmi:value", "false");
						textBoxElement4.appendChild(editableElement4);
						
						
						Element linkConstraintIDElement;
						linkConstraintIDElement = (node.getOwnerDocument()).createElement("linkConstraintID");
						linkConstraintIDElement.setAttribute("xmi:idref", textBoxIdPrefix +  (textBoxCounter-2));
						newElement.appendChild(linkConstraintIDElement);
						
						Element linkStereotypeIDElement;
						linkStereotypeIDElement = (node.getOwnerDocument()).createElement("linkStereotypeID");
						linkStereotypeIDElement.setAttribute("xmi:idref", textBoxIdPrefix +  (textBoxCounter-1));
						newElement.appendChild(linkStereotypeIDElement);
						
						Element linktaggedValuesIDElement;
						linktaggedValuesIDElement = (node.getOwnerDocument()).createElement("linktaggedValuesID");
						linktaggedValuesIDElement.setAttribute("xmi:idref", textBoxIdPrefix +  textBoxCounter);
						newElement.appendChild(linktaggedValuesIDElement);
						
						textBoxCounter++;
						
						node.appendChild(newElement);
					}
					
					for (int i = 0; i < terminalXMLNodesList.size(); i++){
						
						TerminalXMLNode newNode = ((TerminalXMLNode)terminalXMLNodesList.get(i));
						
						Element newElement;
						newElement = (node.getOwnerDocument()).createElement("mdElement");
						
						if (newNode.getType().equalsIgnoreCase(initialType)){//its an initial node
							
							newElement.setAttribute("elementClass", "PseudoNode");
							newElement.setAttribute("xmi:id", newNode.getIntialWrapperPrefixId());
							
							Element elementIDElement;
							elementIDElement = (node.getOwnerDocument()).createElement("elementID");
							elementIDElement.setAttribute("xmi:idref", newNode.getId());
							newElement.appendChild(elementIDElement);
							
							
							Element geometryElement;
							geometryElement = (node.getOwnerDocument()).createElement("geometry");
							geometryElement.setTextContent("200, 20, 20, 20");
							newElement.appendChild(geometryElement);
							
							Element mdOwnedViewsElement;
							mdOwnedViewsElement = (node.getOwnerDocument()).createElement("mdOwnedViews");
							newElement.appendChild(mdOwnedViewsElement);
							
							Element mdElement;
							mdElement = (node.getOwnerDocument()).createElement("mdElement");
							mdElement.setAttribute("xmi:id", textBoxIdPrefix +  textBoxCounter);
							mdElement.setAttribute("elementClass", "TextBox");
							mdOwnedViewsElement.appendChild(mdElement);
							
							Element geometryMdElement;
							geometryMdElement = (node.getOwnerDocument()).createElement("geometry");
							geometryMdElement.setTextContent("200, 20, 20, 20");
							mdElement.appendChild(geometryMdElement);
							
							Element visibleElement;
							visibleElement = (node.getOwnerDocument()).createElement("visible");
							visibleElement.setAttribute("xmi:value", "false");
							mdElement.appendChild(visibleElement);
							
							Element nameIDElement;
							nameIDElement = (node.getOwnerDocument()).createElement("nameID");
							nameIDElement.setAttribute("xmi:idref", textBoxIdPrefix +  textBoxCounter);
							newElement.appendChild(nameIDElement);
							
							textBoxCounter++;
							
						}
						else{//its a final Node
							
							newElement.setAttribute("elementClass", "PseudoNode");
							newElement.setAttribute("xmi:id", newNode.getFinalWrapperPrefixId());
							
							Element elementIDElement;
							elementIDElement = (node.getOwnerDocument()).createElement("elementID");
							elementIDElement.setAttribute("xmi:idref", newNode.getId());
							newElement.appendChild(elementIDElement);
							
							
							Element geometryElement;
							geometryElement = (node.getOwnerDocument()).createElement("geometry");
							geometryElement.setTextContent("200," + layoutSeparator + ", 20, 20");
							newElement.appendChild(geometryElement);
							
							Element mdOwnedViewsElement;
							mdOwnedViewsElement = (node.getOwnerDocument()).createElement("mdOwnedViews");
							newElement.appendChild(mdOwnedViewsElement);
							
							Element mdElement;
							mdElement = (node.getOwnerDocument()).createElement("mdElement");
							mdElement.setAttribute("xmi:id", textBoxIdPrefix +  textBoxCounter);
							mdElement.setAttribute("elementClass", "TextBox");
							mdOwnedViewsElement.appendChild(mdElement);
							
							Element geometryMdElement;
							geometryMdElement = (node.getOwnerDocument()).createElement("geometry");
							geometryMdElement.setTextContent("200," + layoutSeparator + ", 20, 20");
							layoutSeparator =  layoutSeparator + seperationDistance;
							mdElement.appendChild(geometryMdElement);
							
							Element visibleElement;
							visibleElement = (node.getOwnerDocument()).createElement("visible");
							visibleElement.setAttribute("xmi:idref", "false");
							mdElement.appendChild(visibleElement);
							
							Element nameIDElement;
							nameIDElement = (node.getOwnerDocument()).createElement("nameID");
							nameIDElement.setAttribute("xmi:idref", textBoxIdPrefix +  textBoxCounter);
							newElement.appendChild(nameIDElement);
							
							textBoxCounter++;
							
						}
						
						node.appendChild(newElement);
						
					}
					
				}
				
			}
			
			NodeList children = node.getChildNodes();
			
			if (children != null)
			{
				int len = children.getLength();
				for (int i = 0; i < len; i++)
					createActivityDiagram(children.item(i));
			}
			
			break;
		}
		}//end of switch
		
	}
	
	private String getWrapper(String keyId) {
		
		for (int i = 0; i < actionXMLNodesList.size(); i++){
			ActionXMLNode newNode = ((ActionXMLNode)actionXMLNodesList.get(i));
			
			if (newNode.getId().equalsIgnoreCase(keyId)){
				return newNode.getActionWrapperPrefixId();
			}
		}
		
		for (int i = 0; i < forkXMLNodesList.size(); i++){
			ControlXMLNode newNode = ((ControlXMLNode)forkXMLNodesList.get(i));
			
			if (newNode.getId().equalsIgnoreCase(keyId)){
				return newNode.getForkJoinWrapperPrefixId();
			}
		}
		
		for (int i = 0; i < decisionXMLNodesList.size(); i++){
			ControlXMLNode newNode = ((ControlXMLNode)decisionXMLNodesList.get(i));
			
			if (newNode.getId().equalsIgnoreCase(keyId)){
				return newNode.getDecisionWrapperPrefixId();
			}
		}
		
		for (int i = 0; i < terminalXMLNodesList.size(); i++){
			TerminalXMLNode newNode = ((TerminalXMLNode)terminalXMLNodesList.get(i));
			
			if (newNode.getId().equalsIgnoreCase(keyId)){
				
				if (newNode.getType().equalsIgnoreCase(initialType)){
					return newNode.getIntialWrapperPrefixId();
				}
				else{
					return newNode.getFinalWrapperPrefixId();
				}
			}
		}
		
		//should never get here
		return null;
	}

	private ControlXMLFlow getControlXMLFLow(String id, String direction) {
		
		for (int i = 0 ; i < controlXMLFlowsList.size();i++){
			
			ControlXMLFlow flow = ((ControlXMLFlow)controlXMLFlowsList.get(i));
			
			if (direction.equalsIgnoreCase("outgoing")){
				if (flow.getSource().equalsIgnoreCase(id)){
					return flow;
				}
			}
			else{//incoming
				if (flow.getTarget().equalsIgnoreCase(id)){
					return flow;
				}
			}
			
		}
		
		//should not get here
		return null;
	}

	//	 Retrive probe message as XML string
	public String getXMLString() {
		return xmlStr;
	}
	
	private void generateXMLString(Document doc) {
		
		StringWriter  strWriter    = null;
		XMLSerializer probeMsgSerializer   = null;
		OutputFormat  outFormat    = null;
		try {
			probeMsgSerializer = new XMLSerializer();
			strWriter = new StringWriter();
			outFormat = new OutputFormat();
			
			// Setup format settings
			outFormat.setIndenting(true);
			outFormat.setIndent(4);
			
			// Define a Writer
			probeMsgSerializer.setOutputCharStream(strWriter);
			
			// Apply the format settings
			probeMsgSerializer.setOutputFormat(outFormat);
			
			// Serialize XML Document
			probeMsgSerializer.serialize(doc);
			xmlStr = strWriter.toString();
			strWriter.close();
			
		} catch (IOException ioEx) {
			System.out.println("Error " + ioEx);
		}
	}
	
	
	
	private ControlXMLNode getDecisionXMLNode(ControlNode currentControlNode) {
		
		String id = "" + currentControlNode.getControlID();
		String prefixedId = decisionIdPrefix + id;
		
		for (int i = 0 ; i < decisionXMLNodesList.size() ; i++){
			ControlXMLNode currentXMLNode = ((ControlXMLNode)decisionXMLNodesList.get(i));
			
			if (currentXMLNode.getId().equalsIgnoreCase(prefixedId)){
				return currentXMLNode;
			}
		}
		
		return null;
	}
	
	private ControlXMLNode getForkXMLNode(ControlNode currentControlNode) {
		
		String id = "" + currentControlNode.getControlID();
		String prefixedId = forkIdPrefix + id;
		
		for (int i = 0 ; i < forkXMLNodesList.size() ; i++){
			ControlXMLNode currentXMLNode = ((ControlXMLNode)forkXMLNodesList.get(i));
			
			if (currentXMLNode.getId().equalsIgnoreCase(prefixedId)){
				return currentXMLNode;
			}
		}
		
		return null;
	}
	
	private TerminalXMLNode getTerminalXMLNode(ControlNode currentControlNode) {
		
		String id = "" + currentControlNode.getControlID();
		String prefixedId;
		
		if (currentControlNode.getType().equalsIgnoreCase(currentControlNode.TYPE_initial)){
			prefixedId =  initialIdPrefix + id;
		}
		else{
			prefixedId =  finalIdPrefix + id;
		} 
		
		for (int i = 0 ; i < terminalXMLNodesList.size() ; i++){
			TerminalXMLNode currentXMLNode = ((TerminalXMLNode)terminalXMLNodesList.get(i));
			
			if (currentXMLNode.getId().equalsIgnoreCase(prefixedId)){
				return currentXMLNode;
			}
		}
		
		//should never get here
		return null;
	}
	
	private ActionXMLNode getActionXMLNodeFromAction(Action sourceAction) {
		
		String id = "" + sourceAction.getActionID();
		String prefixedId =  actionIdPrefix + id;
		
		for (int i = 0 ; i < actionXMLNodesList.size() ; i++){
			
			ActionXMLNode currentXMLNode= ((ActionXMLNode)actionXMLNodesList.get(i)); 
			
			if (currentXMLNode.getId().equalsIgnoreCase(prefixedId)){
				return currentXMLNode;
			}
			
		}
		
		//it should never here
		return null;
	}
	
	private String getDescription(Action sourceAction) {
		
		if (sourceAction.getInclude().length() > 0){
			return sourceAction.getInclude();
		}
		else if (sourceAction.getPerform().length() > 0){
			return sourceAction.getPerform();
		}
		else{
			return sourceAction.getDescription();
		}
		
	}
}
