package reucd.gui;

/**
 * Created on 2004-01-17
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */


import java.awt.Color;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.ToolTipManager;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;


import reucd.main.*;


/**
 * @author Mohamed El-Attar
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
/** This class implements JTree used in the application representing
 * either the bands and venues xml file or schedule xml file.
 * */

public class ActorTree {
	
	private ArrayList actorList;
	
	public JTree createTree(UseCaseDescriptions descriptions) {
		actorList = descriptions.getActors();
		
		DefaultMutableTreeNode actorNode = new DefaultMutableTreeNode("Actors");


		/** actor tree nodes creation */
		if (actorList != null) {
			
			
			for (int i= 0; i < actorList.size(); i++) {
				Actor actor = (Actor) actorList.get(i);
		
				DefaultMutableTreeNode newActor = 
					new DefaultMutableTreeNode(actor.getName());
				actorNode.add( newActor );
				
				DefaultMutableTreeNode actorName = new DefaultMutableTreeNode("Name: "+actor.getName() );
				newActor.add( actorName );
				
				if (actor.isSpecializing()){
					DefaultMutableTreeNode specializesLabel = new DefaultMutableTreeNode("Specializes: " + actor.getSpecializesActor());
					newActor.add( specializesLabel );
				}
			}	/** end of for loop */
		}
		
		JTree tree = new JTree(actorNode);
		
		/** enables tool tip mechanism */
		ToolTipManager.sharedInstance().registerComponent(tree);
		
		/** Set the icon for leaf nodes */
		ImageIcon leafIcon = new ImageIcon("leaf_node.gif");

		/** rendering tree nodes */		
		DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();

		if (leafIcon != null) {			
			renderer.setLeafIcon(leafIcon);
		} else {
			/** Leaf icon missing, using default */
		}
		renderer.setBackground(new Color(220, 235, 245));
		renderer.setBackgroundNonSelectionColor(new Color(220, 235, 245));
		renderer.setToolTipText("actors");
		tree.setCellRenderer(renderer);
		
		return tree;
	}

}
