/**
 * Created on 2004-11-23
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package reucd.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import reucd.reverse.DescriptionSkeletonWriter;
import reucd.reverse.XMLLoader;
import reucd.reverse.DataManager;

import reucd.main.REUCD;
import reucd.util.ExampleFileFilter;
import reucd.main.UseCaseDescriptions;

/**
 * @author Mohamed El-Attar
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

/** This class implements the menu bar for the whole application */
public class MainMenuBar extends JMenuBar {

	public File currentDir = new File("C:\\reucd\\");

	
	boolean isUCDesriptionLoaded = false;
	boolean isUCDiagramLoaded = false;

	public MainMenuBar(final REUCD window) {		

		
		/********************************************************
		 * File menu											* 
		 *******************************************************/

		JMenu mFile = new JMenu("File");
		mFile.setMnemonic(KeyEvent.VK_F);
		add(mFile);
		
		JMenuItem miLoadXml = new JMenuItem("Load Use Case Descriptions");
		miLoadXml.setMnemonic(KeyEvent.VK_O);
		miLoadXml.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_O, ActionEvent.CTRL_MASK));
		mFile.add(miLoadXml);
		
		miLoadXml.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {

				JFileChooser chooser = new JFileChooser(currentDir);
				chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				
				ExampleFileFilter filter = new ExampleFileFilter();
				filter.addExtension("ucd");
				filter.setDescription("Use case description file");
				chooser.setFileFilter(filter);
				chooser.setDialogTitle("Load Use Case Description File");
				window.setDescriptions(new UseCaseDescriptions());

				int returnVal = chooser.showOpenDialog(window);
				if(returnVal != JFileChooser.APPROVE_OPTION) {
					return;
				}
				currentDir = chooser.getCurrentDirectory();
				window.setCurrentFile(chooser.getSelectedFile().getAbsolutePath());
				
				UseCaseDescriptions descriptions = window.getDescriptions();
				descriptions.readFile(chooser.getSelectedFile().getPath());
				descriptions.createActivityDiagrams();
				descriptions.createDecisionNodesForAlternativeFlows();
				descriptions.createDecisionNodesForExtensionPoints();
				descriptions.createActivityEdgesForBasicFlows();
				descriptions.createActivityEdgesForSubflows();
				descriptions.createPerformRelationships();
				descriptions.createIncludeRelationships();
				descriptions.createAssociationRelationships();
				descriptions.createGeneralizationRelationships();
				descriptions.removeFakeNodes();
				descriptions.removeUnrequiredJoinNodes();

				System.out.println("done");
				
				isUCDesriptionLoaded = true;

				window.display();
			}
		});
		
		JMenuItem miLoadUCDiagram = new JMenuItem("Load Use Case Diagram");
		miLoadUCDiagram.setMnemonic(KeyEvent.VK_D);
		miLoadUCDiagram.setAccelerator(KeyStroke.getKeyStroke(
				KeyEvent.VK_D, ActionEvent.CTRL_MASK));
		mFile.add(miLoadUCDiagram);
		
		miLoadUCDiagram.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {

				JFileChooser chooser = new JFileChooser(currentDir);
				chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
				
				ExampleFileFilter filter = new ExampleFileFilter();
				filter.addExtension("xml");
				filter.setDescription("Use case diagram file");
				chooser.setFileFilter(filter);
				chooser.setDialogTitle("Load Use Case Diagram File");
				window.setDescriptions(new UseCaseDescriptions());

				int returnVal = chooser.showOpenDialog(window);
				if(returnVal != JFileChooser.APPROVE_OPTION) {
					return;
				}
				currentDir = chooser.getCurrentDirectory();
				window.setCurrentFile(chooser.getSelectedFile().getAbsolutePath());


				System.out.println("done");
				
				isUCDiagramLoaded = true;
				DataManager.clearAll();
				XMLLoader xml = new XMLLoader(chooser.getSelectedFile().getPath());
				xml.createUseCaseDiagramObjects();

				window.display();
				
			}
		});
		
		mFile.addSeparator();

		JMenuItem miCreateUCDescriptions = new JMenuItem("Create Use Case Descriptions");
		miCreateUCDescriptions.setAccelerator(KeyStroke.getKeyStroke(
						KeyEvent.VK_F2, ActionEvent.ALT_MASK));
		miCreateUCDescriptions.setMnemonic(KeyEvent.VK_C);
		mFile.add(miCreateUCDescriptions);
		
		miCreateUCDescriptions.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				DescriptionSkeletonWriter descriptionWriter = new DescriptionSkeletonWriter ();
				descriptionWriter.writeDescriptions();
			}
		});
		

		JMenuItem miCreateUCD = new JMenuItem("Create Use Case Diagram");
		miCreateUCD.setAccelerator(KeyStroke.getKeyStroke(
						KeyEvent.VK_F3, ActionEvent.ALT_MASK));
		miCreateUCD.setMnemonic(KeyEvent.VK_C);
		mFile.add(miCreateUCD);
		
		miCreateUCD.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				UseCaseDescriptions descriptions = window.getDescriptions();
				descriptions.createUseCaseDiagram(window);
			}
		});

		mFile.addSeparator();

		JMenuItem miExit = new JMenuItem("Exit");
		miExit.setAccelerator(KeyStroke.getKeyStroke(
						KeyEvent.VK_F4, ActionEvent.ALT_MASK));
		miExit.setMnemonic(KeyEvent.VK_X);
		mFile.add(miExit);
		
		miExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);				
			}
		});


		
		JMenu mHelp = new JMenu("Help");
		mHelp.setMnemonic(KeyEvent.VK_H);
		add(mHelp);

		JMenuItem miCredits = new JMenuItem("Credits");
		miCredits.setMnemonic(KeyEvent.VK_C);
		miCredits.setAccelerator(KeyStroke.getKeyStroke(
						KeyEvent.VK_F1,0));
		mHelp.add(miCredits);
		
		miCredits.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {

				CreditsDialog cd = new CreditsDialog(window);
				cd.setVisible(true);
			}
		});
		
		JMenuItem miAboutXMLScheduler2004 = new JMenuItem("About REUCD 1.0");
		miAboutXMLScheduler2004.setMnemonic(KeyEvent.VK_A);
		miAboutXMLScheduler2004.setAccelerator(KeyStroke.getKeyStroke(
								KeyEvent.VK_F5,0));
		mHelp.add(miAboutXMLScheduler2004);
		
		miAboutXMLScheduler2004.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent arg0) {

				AboutDialog ad = new AboutDialog(window);
				ad.setVisible(true);				
			}
		});
		
		
	}


	public boolean isUCDesriptionLoaded() {
		return isUCDesriptionLoaded;
	}

	public void setUCDesriptionLoaded(boolean isUCDesriptionLoaded) {
		this.isUCDesriptionLoaded = isUCDesriptionLoaded;
	}

	public boolean isUCDiagramLoaded() {
		return isUCDiagramLoaded;
	}

	public void setUCDiagramLoaded(boolean isUCDiagramLoaded) {
		this.isUCDiagramLoaded = isUCDiagramLoaded;
	}

	

}
