package reucd.gui;

/**
 * Created on 2004-01-17
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */


import java.awt.Color;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.ToolTipManager;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

import reucd.main.*;


public class RelationTree {
	
	private ArrayList relationshipsList;
	

	public RelationTree() {
		
	}

	/** 
	 * @return JTree constructed and renedered tree
	 */
	public JTree createTree(UseCaseDescriptions descriptions) {

		relationshipsList = descriptions.getRelationships();
		
		DefaultMutableTreeNode relationNode = new DefaultMutableTreeNode("Relationships");
		
		
		//---nodes for generalizations----
		DefaultMutableTreeNode generalizationNode = new DefaultMutableTreeNode ("Generalizations");
		relationNode.add( generalizationNode );
		
		DefaultMutableTreeNode useCaseGeneralizationNode = new DefaultMutableTreeNode ("Use Case Generalizations");
		generalizationNode.add( useCaseGeneralizationNode );
		
		DefaultMutableTreeNode actorGeneralizationNode = new DefaultMutableTreeNode ("Actor Generalizations");
		generalizationNode.add( actorGeneralizationNode );
		
		
		
		//----nodes for dependancies----
		DefaultMutableTreeNode dependancyNode = new DefaultMutableTreeNode ("Dependancies");
		relationNode.add( dependancyNode );
		
		DefaultMutableTreeNode extendNode = new DefaultMutableTreeNode ("Extend Relationships");
		dependancyNode.add( extendNode );
		
		DefaultMutableTreeNode includeNode = new DefaultMutableTreeNode ("Include Relationships");
		dependancyNode.add( includeNode);
		
		DefaultMutableTreeNode performNode = new DefaultMutableTreeNode ("Perform Dependancies");
		dependancyNode.add( performNode);
		
		
		
		//---nodes for associations-----
		DefaultMutableTreeNode associationNode = new DefaultMutableTreeNode ("Associations");
		relationNode.add( associationNode );
		
		/** relationship tree nodes creation */
		if (relationshipsList != null) {
			

			
			for (int i= 0; i < relationshipsList.size(); i++) {
				Relationship relationship = (Relationship) relationshipsList.get(i);
	
				if (relationship.getType().equalsIgnoreCase(relationship.TYPE_GENERALIZATION) ||
						relationship.getType().equalsIgnoreCase(relationship.TYPE_GENERALIZATION_ACTOR)){

					if (relationship.getType().equalsIgnoreCase(relationship.TYPE_GENERALIZATION)){
						
						DefaultMutableTreeNode newGeneralizationUseCase = new DefaultMutableTreeNode("Generalization");
						useCaseGeneralizationNode.add( newGeneralizationUseCase );
						
						DefaultMutableTreeNode newSpecializedUseCase = new DefaultMutableTreeNode("Parent Use Case: "+ relationship.getSupplierUseCase().getNameSection().getName() );
						newGeneralizationUseCase.add( newSpecializedUseCase );
						
						DefaultMutableTreeNode newGeneralizedUseCase = new DefaultMutableTreeNode("Child Use Case: "+ relationship.getClientUseCase().getNameSection().getName() );
						newGeneralizationUseCase.add( newGeneralizedUseCase );
						
						descriptions.getUseCaseGeneralizationList().add(relationship);
					}
					else{
						
						DefaultMutableTreeNode newGeneralizationActor = new DefaultMutableTreeNode("Generalization");
						actorGeneralizationNode.add( newGeneralizationActor );
						
						DefaultMutableTreeNode newSpecializedActor = new DefaultMutableTreeNode("Parent Actor: "+ relationship.getParentActor().getName());
						newGeneralizationActor.add( newSpecializedActor );
						
						DefaultMutableTreeNode newGeneralizedActor = new DefaultMutableTreeNode("Child Actor: "+ relationship.getChildActor().getName());
						newGeneralizationActor.add( newGeneralizedActor );
						
						descriptions.getActorGeneralizationList().add(relationship);
					}
					
				}
				else if (relationship.getType().equalsIgnoreCase(relationship.TYPE_EXTEND) ||
						relationship.getType().equalsIgnoreCase(relationship.TYPE_INCLUDE) ||
						relationship.getType().equalsIgnoreCase(relationship.TYPE_PERFORM)){
					
					if (relationship.getType().equalsIgnoreCase(relationship.TYPE_EXTEND)){
						
						DefaultMutableTreeNode newExtend = new DefaultMutableTreeNode("Extend");
						extendNode.add( newExtend );
						
						DefaultMutableTreeNode extendingUseCaseLabel = new DefaultMutableTreeNode("Extension Use Case: "+ relationship.getClientUseCase().getNameSection().getName() );
						newExtend.add( extendingUseCaseLabel );
						
						DefaultMutableTreeNode baseUseCaseLabel = new DefaultMutableTreeNode("Base Use Case: "+ relationship.getSupplierUseCase().getNameSection().getName() );
						newExtend.add( baseUseCaseLabel );
						
						descriptions.getExtendList().add(relationship);
						
					}
					else if (relationship.getType().equalsIgnoreCase(relationship.TYPE_INCLUDE)){
						
						DefaultMutableTreeNode newInclude = new DefaultMutableTreeNode("Include");
						includeNode.add( newInclude );
						
						DefaultMutableTreeNode inclusionUseCaseLabel = new DefaultMutableTreeNode("Inclusion Use Case: "+ relationship.getSupplierUseCase().getNameSection().getName() );
						newInclude.add( inclusionUseCaseLabel);
						
						DefaultMutableTreeNode baseUseCaseLabel = new DefaultMutableTreeNode("Base Use Case: "+ relationship.getClientUseCase().getNameSection().getName() );
						newInclude.add( baseUseCaseLabel );
						
						descriptions.getIncludeList().add(relationship);
					}
					else{
						
						DefaultMutableTreeNode newPerform = new DefaultMutableTreeNode("Perform");
						performNode.add( newPerform );
						
						DefaultMutableTreeNode actionLabel = new DefaultMutableTreeNode("Action: " + relationship.getClientAction().getPerform());
						newPerform.add( actionLabel);
						
						DefaultMutableTreeNode useCaseLabel = new DefaultMutableTreeNode("Use Case: " + relationship.getClientActivityDiagram().getOwningUseCaseName());
						newPerform.add( useCaseLabel);
						
						DefaultMutableTreeNode sourceLabel = new DefaultMutableTreeNode("Source Activity Diagram: " + relationship.getClientActivityDiagram().getName());
						newPerform.add( sourceLabel);
						
						DefaultMutableTreeNode destinationLabel = new DefaultMutableTreeNode("Destination Subflow:" + relationship.getSupplierActivityDiagram().getName());
						newPerform.add( destinationLabel );
						
						descriptions.getPerformList().add(relationship);
						
					}
					
				}
				else{
					
					DefaultMutableTreeNode newAssociation = new DefaultMutableTreeNode("Association");
					associationNode.add( newAssociation );
					
					DefaultMutableTreeNode useCaseLabel = new DefaultMutableTreeNode("Use Case: "+ relationship.getUseCaseAssociation().getNameSection().getName() );
					newAssociation.add( useCaseLabel );
					
					DefaultMutableTreeNode actorLabel = new DefaultMutableTreeNode("Actor: "+ relationship.getActorAssociation().getName() );
					newAssociation.add( actorLabel );
					
					descriptions.getAssociationList().add(relationship);
				}
			

			}	
		}
		
		JTree tree = new JTree(relationNode);
		
		/** enables tool tip mechanism */
		ToolTipManager.sharedInstance().registerComponent(tree);
		
		/** Set the icon for leaf nodes */
		ImageIcon leafIcon = new ImageIcon("leaf_node.gif");

		/** rendering tree nodes */		
		DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();

		if (leafIcon != null) {			
			renderer.setLeafIcon(leafIcon);
		} else {
			/** Leaf icon missing, using default */
		}
		renderer.setBackground(new Color(220, 235, 245));
		renderer.setBackgroundNonSelectionColor(new Color(220, 235, 245));
		renderer.setToolTipText("relationships");
		tree.setCellRenderer(renderer);
		
		return tree;
		
	}
	
	
}
