/**
 * Created on 2004-01-17
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package reucd.gui;

import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JTree;
import javax.swing.ToolTipManager;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeSelectionModel;
import reucd.main.*;


/**
 * @author Mohamed El-Attar
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
/** This class implements JTree used in the application representing
 * either the bands and venues xml file or schedule xml file.
 * */
public class UseCaseTree implements TreeSelectionListener, MouseListener {

	private ArrayList useCaseList;
	UseCaseDescriptions descriptions;
	
	JTree tree;
	REUCD window;

	public UseCaseTree(REUCD window) {
		this.window = window;
	}

	/** 
	 * @return JTree constructed and renedered tree
	 */
	public JTree createTree(UseCaseDescriptions descriptions) {
	
		useCaseList = descriptions.getUseCases();
		this.descriptions = descriptions;
		
		DefaultMutableTreeNode useCaseNode = new DefaultMutableTreeNode("Use Cases");

		
		/** use case tree nodes creation */
		if (useCaseList != null) {

			
			for (int i= 0; i < useCaseList.size(); i++) {
				UseCase useCase = (UseCase) useCaseList.get(i);
				NameSection nameSection = ((NameSection)useCase.getNameSection());
				
		
				DefaultMutableTreeNode newUseCase = new DefaultMutableTreeNode(nameSection.getName() );
				useCaseNode.add( newUseCase );
				
				DefaultMutableTreeNode useCaseName = new DefaultMutableTreeNode("Name: "+ nameSection.getName() );
				newUseCase.add( useCaseName );
				
				
				if (nameSection.isAbstract()){
					DefaultMutableTreeNode abstractLabel = new DefaultMutableTreeNode("Abstract");
					newUseCase.add( abstractLabel );
				}
				
				if (nameSection.isSpecializing()){
					DefaultMutableTreeNode specializesLabel = new DefaultMutableTreeNode("Specializes: " + nameSection.getSpecializesUseCase());
					newUseCase.add( specializesLabel );
				}
				
				if (nameSection.isImplementing()){
					DefaultMutableTreeNode implementsLabel = new DefaultMutableTreeNode("Implements: " + nameSection.getImplementsUsecase());
					newUseCase.add( implementsLabel );
				}
				
				int j;
				ArrayList activityDiagrams = ((ArrayList)useCase.getActivityDiagrams());
				for ( j= 0 ; j < activityDiagrams.size(); j++){
					
					ActivityDiagram activityDiagram = ((ActivityDiagram)activityDiagrams.get(j));
					DefaultMutableTreeNode activityDiagramLabel = new DefaultMutableTreeNode("Activity Diagram");
					newUseCase.add( activityDiagramLabel );
					
					DefaultMutableTreeNode activityDiagramLabelName = new DefaultMutableTreeNode(activityDiagram);
					activityDiagramLabel.add(activityDiagramLabelName);
					
					DefaultMutableTreeNode activityDiagramLabelType = new DefaultMutableTreeNode("Diagram Type: " + activityDiagram.getType());
					activityDiagramLabel.add(activityDiagramLabelType);
					
				}
				
				
				
				
				//---create  the inter-diagrammatic edges-----
				ArrayList interDiagrammaticEdges = new ArrayList ();
				getInterDiagrammaticEdges(useCase, descriptions,  interDiagrammaticEdges);
				
				DefaultMutableTreeNode interDiagramLabel = new DefaultMutableTreeNode("Edges Between Activity Diagrams");
				newUseCase.add( interDiagramLabel );
				
				for ( j= 0 ; j < interDiagrammaticEdges.size(); j++){
					ActivityEdge currentActivityEdge = ((ActivityEdge)interDiagrammaticEdges.get(j)); 
					
					DefaultMutableTreeNode newEdge = new DefaultMutableTreeNode("Activity Edge");
					interDiagramLabel.add( newEdge );
					
					if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_activityDiagram)){
						
						ActivityDiagram activityDiagram = ((ActivityDiagram)currentActivityEdge.getSourceActivityDiagram());
						
						DefaultMutableTreeNode newSourceAD = new DefaultMutableTreeNode("Source -> Activity Diagram: " + activityDiagram.getName());
						newEdge.add( newSourceAD );
						
						if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
							Action destinationAction = ((Action)currentActivityEdge.getDestinationAction()); 
							
							DefaultMutableTreeNode newDestinationAction = new DefaultMutableTreeNode("Destination -> Action ID: " + destinationAction.getActionID());
							newEdge.add( newDestinationAction );
							
							DefaultMutableTreeNode newDestinationActor = new DefaultMutableTreeNode("Actor: " + destinationAction.getPartition());
							newDestinationAction.add( newDestinationActor );
							
							DefaultMutableTreeNode newDestinationDescription = new DefaultMutableTreeNode( getDescription(destinationAction));
							newDestinationAction.add( newDestinationDescription );
						}
						else if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
							ControlNode destinationControlNode = ((ControlNode)currentActivityEdge.getDestinationControlNode());
							
							DefaultMutableTreeNode newDestinationControlNode = new DefaultMutableTreeNode("Destination -> " + destinationControlNode.getType() + " ID: " + destinationControlNode.getControlID());
							newEdge.add( newDestinationControlNode );
							
						}
						
					}
					
					else if (currentActivityEdge.getDestinationType().equalsIgnoreCase(currentActivityEdge.TYPE_activityDiagram)){
						
						ActivityDiagram activityDiagram = ((ActivityDiagram)currentActivityEdge.getDestinationActivityDiagram());
						
						if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_action)){
							
							Action sourceAction = ((Action)currentActivityEdge.getSourceAction());
							
							DefaultMutableTreeNode newSourceAction = new DefaultMutableTreeNode("Source -> Action ID: " + sourceAction.getActionID());
							newEdge.add( newSourceAction );
							
							DefaultMutableTreeNode newSourceActor = new DefaultMutableTreeNode("Actor: " + sourceAction.getPartition());
							newSourceAction.add( newSourceActor );
							
							DefaultMutableTreeNode newSourceDescription = new DefaultMutableTreeNode( getDescription(sourceAction));
							newSourceAction.add( newSourceDescription );
						}
						else if (currentActivityEdge.getSourceType().equalsIgnoreCase(currentActivityEdge.TYPE_controlNode)){
							
							ControlNode sourceControlNode = ((ControlNode)currentActivityEdge.getSourceControlNode());
							
							DefaultMutableTreeNode newSourceControlNode = new DefaultMutableTreeNode("Source -> " + sourceControlNode.getType() + " ID: " + sourceControlNode.getControlID());
							newEdge.add( newSourceControlNode );
						}
						
						
						DefaultMutableTreeNode newDestinationAD = new DefaultMutableTreeNode("Destination -> Activity Diagram: " + activityDiagram.getName());
						newEdge.add( newDestinationAD );
						
					}
				}
				
				
			}	/** end of for loop */
		}

				
		tree = new JTree(useCaseNode);
		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		
		//Listen for when the selection changes.
	    tree.addTreeSelectionListener(this);
	    tree.addMouseListener(this);
	    
	    

		
		/** enables tool tip mechanism */
		ToolTipManager.sharedInstance().registerComponent(tree);
		
		/** Set the icon for leaf nodes */
		ImageIcon leafIcon = new ImageIcon("leaf_node.gif");

		/** rendering tree nodes */		
		DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();

		if (leafIcon != null) {			
			renderer.setLeafIcon(leafIcon);
		} else {
			/** Leaf icon missing, using default */
		}
		renderer.setBackground(new Color(220, 235, 245));
		renderer.setBackgroundNonSelectionColor(new Color(220, 235, 245));
		renderer.setToolTipText("use cases");
		tree.setCellRenderer(renderer);
		
		return tree;
	}

	private void  getInterDiagrammaticEdges(UseCase useCase, UseCaseDescriptions descriptions, ArrayList interDiagrammaticEdges) {
		
		ArrayList activityEdges = descriptions.getActivityEdges();
		
		
		int i;
		for (i = 0 ; i < activityEdges.size() ; i++){
			ActivityEdge activityEdge = ((ActivityEdge)activityEdges.get(i));
			ActivityDiagram currentActivityDiagram;
			
			
			if (activityEdge.getDestinationType().equalsIgnoreCase(activityEdge.TYPE_activityDiagram)){
				currentActivityDiagram  = activityEdge.getDestinationActivityDiagram();
				if (currentActivityDiagram.getOwningUseCaseName().equalsIgnoreCase(((NameSection)useCase.getNameSection()).getName())){
					interDiagrammaticEdges.add(activityEdge);
				}
			}
			else if (activityEdge.getSourceType().equalsIgnoreCase(activityEdge.TYPE_activityDiagram)){
				currentActivityDiagram  = activityEdge.getSourceActivityDiagram();
				if (currentActivityDiagram.getOwningUseCaseName().equalsIgnoreCase(((NameSection)useCase.getNameSection()).getName())){
					interDiagrammaticEdges.add(activityEdge);
				}
			}
			
	
		}
	}

	public void valueChanged(TreeSelectionEvent e) {

	}

	public void mouseClicked(MouseEvent arg0) {

			
		DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();
		
		if (node == null) {
			return;
		}
		
		Object nodeInfo = node.getUserObject();
		
		if(nodeInfo.getClass().toString().equalsIgnoreCase("class reucd.main.ActivityDiagram")){
			ActivityDiagram activityDiagram = (ActivityDiagram)nodeInfo;
			ActivityDiagramFrame  add = new ActivityDiagramFrame(window, activityDiagram, descriptions.getActivityEdges());
			add.setVisible(true);
		}

	}

	public void mousePressed(MouseEvent arg0) {
	}

	public void mouseReleased(MouseEvent arg0) {
	}

	public void mouseEntered(MouseEvent arg0) {
	}

	public void mouseExited(MouseEvent arg0) {
	}
	
	
	private String getDescription(Action sourceAction) {
		
		if (sourceAction.getInclude().length() > 0){
			return sourceAction.getInclude();
		}
		else if (sourceAction.getPerform().length() > 0){
			return sourceAction.getPerform();
		}
		else{
			return sourceAction.getDescription();
		}
		
	}


}
