package reucd.main;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;


import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTree;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;


import reucd.gui.*;


/*
 * Created on Dec 8, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Work
 *
 * 
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class REUCD extends JFrame{
	
	UseCaseDescriptions descriptions = new UseCaseDescriptions();
	private JPanel mainPane = null;
	private JTree useCaseTree = null;
	private JTree actorTree = null;
	private JTree relationTree = null;
	private String currentFile = "";
	private String currentActivityXMLFile = "";
	private static String xmlStr = null;
	/** xml document */
	private static Document doc = null;
	
	public REUCD() {
		super("REUCD");
		
		
		
		/** listeners and handlers */		
		addWindowListener(new WindowsHandler());
		
		/** menu bar */
		MainMenuBar mainMenuBar = new MainMenuBar(this);
		setJMenuBar(mainMenuBar);
		display();
	}
	
	
	public void display() {
		
		
		if (mainPane != null){
			this.getContentPane().remove(mainPane);
		}
		
		
		JLabel fileLabel =
			new JLabel("File loaded: " + currentFile );
		fileLabel.setForeground(Color.BLUE.darker());
		
		/** use case tree initialization */
		UseCaseTree uc_Tree = new UseCaseTree(this);
		this.useCaseTree = uc_Tree.createTree(descriptions);
		useCaseTree.setBackground(new Color(220, 235, 245));
		
		/** actor tree initialization */
		ActorTree act_Tree = new ActorTree();
		this.actorTree = act_Tree.createTree(descriptions);
		actorTree.setBackground(new Color(220, 235, 245));
		
		/** relationships tree initialization */
		RelationTree rel_Tree = new RelationTree();
		this.relationTree = rel_Tree.createTree(descriptions);
		relationTree.setBackground(new Color(220, 235, 245));

		JScrollPane ucTreePane = new JScrollPane();
		ucTreePane.getViewport().add( useCaseTree );
		
		
		JScrollPane actorTreePane = new JScrollPane();
		actorTreePane.getViewport().add( actorTree );
		
		JScrollPane relationTreePane = new JScrollPane();
		relationTreePane.getViewport().add( relationTree );
		
		/** split Pane construction */
		JSplitPane secondSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,actorTreePane,relationTreePane);
		
		JSplitPane firstSplitPane =new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,ucTreePane,secondSplitPane);
		
		firstSplitPane.setOneTouchExpandable(true);
		firstSplitPane.setDividerLocation(300);
		
		secondSplitPane.setOneTouchExpandable(true);
		secondSplitPane.setDividerLocation(300);
		mainPane = new JPanel();
		mainPane.setLayout(new BorderLayout());
		mainPane.add(firstSplitPane, BorderLayout.CENTER);
		mainPane.add(fileLabel, BorderLayout.NORTH);
		
		this.getContentPane().add( mainPane, BorderLayout.CENTER);
		this.pack();
		this.setSize(900, 500);
		this.setVisible(true);
	}
	

	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		new REUCD();
		
		
		
		try 
		{  
		
		  DOMParser parser = new DOMParser();	  
		  parser.parse("Sample Activity.xml");
		  doc = parser.getDocument();

		}catch (Exception e) {	
			  System.err.println("XML reading error: " + e);
		}

	}
	
	
	public class WindowsHandler extends WindowAdapter
	{	public void windowClosing(WindowEvent e) { 
			System.exit(0); 
		}
	}

	/**
	 * Sets the currentFile.
	 * @param currentFile The currentFile to set
	 */
	public void setCurrentFile(String currentFile) {
		this.currentFile= currentFile;
	}
	
	/**
	 * @return String
	 */
	public String getCurrentFile() {
		return currentFile;
	}


	/**
	 * @return Returns the descriptions.
	 */
	public UseCaseDescriptions getDescriptions() {
		return descriptions;
	}


	/**
	 * @param descriptions The descriptions to set.
	 */
	public void setDescriptions(UseCaseDescriptions descriptions) {
		this.descriptions = descriptions;
	}


	public String getCurrentActivityXMLFile() {
		return currentActivityXMLFile;
	}


	public void setCurrentActivityXMLFile(String currentActivityXMLFile) {
		this.currentActivityXMLFile = currentActivityXMLFile;
	}

	
	

}//end of program
