package reucd.main;

public class Relationship {
	
	private String type;
	private String condition;
	private String extensionLocation = "";
	private UseCase clientUseCase;
	private UseCase supplierUseCase;
	private Action clientAction;
	private ActivityDiagram supplierActivityDiagram;
	private ActivityDiagram clientActivityDiagram;
	private Actor actorAssociation;
	private Actor childActor;
	private Actor parentActor;
	private UseCase useCaseAssociation;
	
	//client -> including use case
	//supplier -> included use case
	public final String TYPE_INCLUDE = "INCLUDE";
	
	//client -> source action
	//supplier -> destination activity diagram
	public final String TYPE_PERFORM = "PERFORM";
	
	//client -> extending use case
	//supplier -> extended use case
	public final String TYPE_EXTEND = "EXTEND";
	
	//client -> child
	//supplier -> parent
	public final String TYPE_GENERALIZATION = "GENERALIZATION";
	
	//	client -> child
	//supplier -> parent
	public final String TYPE_GENERALIZATION_ACTOR = "GENERALIZATION ACTOR";
	
	//client -> actor
	//supplier -> use case
	public final String TYPE_ASSOCIATION = "ASSOCIATION";

	public Relationship() {
		type ="";
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public Actor getActorAssociation() {
		return actorAssociation;
	}

	public void setActorAssociation(Actor actorAssociation) {
		this.actorAssociation = actorAssociation;
	}

	public Action getClientAction() {
		return clientAction;
	}

	public void setClientAction(Action clientAction) {
		this.clientAction = clientAction;
	}

	public UseCase getClientUseCase() {
		return clientUseCase;
	}

	public void setClientUseCase(UseCase clientUseCase) {
		this.clientUseCase = clientUseCase;
	}

	public ActivityDiagram getSupplierActivityDiagram() {
		return supplierActivityDiagram;
	}

	public void setSupplierActivityDiagram(ActivityDiagram supplierActivityDiagram) {
		this.supplierActivityDiagram = supplierActivityDiagram;
	}

	public UseCase getSupplierUseCase() {
		return supplierUseCase;
	}

	public void setSupplierUseCase(UseCase supplierUseCase) {
		this.supplierUseCase = supplierUseCase;
	}

	public UseCase getUseCaseAssociation() {
		return useCaseAssociation;
	}

	public void setUseCaseAssociation(UseCase useCaseAssociation) {
		this.useCaseAssociation = useCaseAssociation;
	}

	public String getCondition() {
		return condition;
	}

	public void setCondition(String condition) {
		this.condition = condition;
	}

	public Actor getChildActor() {
		return childActor;
	}

	public void setChildActor(Actor childActor) {
		this.childActor = childActor;
	}

	public Actor getParentActor() {
		return parentActor;
	}

	public void setParentActor(Actor parentActor) {
		this.parentActor = parentActor;
	}

	public ActivityDiagram getClientActivityDiagram() {
		return clientActivityDiagram;
	}

	public void setClientActivityDiagram(ActivityDiagram clientActivityDiagram) {
		this.clientActivityDiagram = clientActivityDiagram;
	}

	public String getExtensionLocation() {
		return extensionLocation;
	}

	public void setExtensionLocation(String extensionLocation) {
		this.extensionLocation = extensionLocation;
	}
	
	
	
}
