/**
 * Created on 2003-11-11
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package reucd.reverse;

import java.util.ArrayList;


/**
 * @author Mohamed El-Attar
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

/** This class is responsible for managing the list of objects
 * i.e. actors, use cases, assocaitions and dependencies. 
 */
public class DataManager {

	private static ArrayList actorList = new ArrayList(); /** list of actors */
	private static ArrayList useCaseList = new ArrayList();/** list of use cases */
	private static ArrayList dependencyList = new ArrayList();	/** list of dependencies */
	private static ArrayList associationList = new ArrayList();	/** list of associations */
	private static ArrayList extensionPointList = new ArrayList();	/** list of extension points */
	private static ArrayList generalizationList = new ArrayList();	/** list of generalizations */


	


	
	/** adds one extension point info to the main list of extension points 
	 * @param extension point object 
	 */		 
	static public void addToGeneralizationList(Generalization generalization) {
		
		try{
			DataManager.generalizationList.add( generalization );
		}
		catch (NullPointerException e){
			DataManager.generalizationList = new ArrayList ();
			DataManager.generalizationList.add( generalization );
		}
	}
	
	/** adds one extension point info to the main list of extension points 
	 * @param extension point object 
	 */		 
	static public void addToExtensionPointList(ExtensionPoint extensionPoint) {
		
		try{
			DataManager.extensionPointList.add( extensionPoint );
		}
		catch (NullPointerException e){
			DataManager.extensionPointList = new ArrayList ();
			DataManager.extensionPointList.add( extensionPoint );
		}
	}
	

	
	/** adds one actor to the main list of actors 
	 * @param actor object 
	 */		 
	static public void addToActorList(Actor actor) {
		
		try{
			DataManager.actorList.add( actor );
		}
		catch (NullPointerException e){
			DataManager.actorList = new ArrayList ();
			DataManager.actorList.add( actor );
		}
	}
	
	/** adds one use case to the main list of use cases 
	 * @param actor object 
	 */		 
	static public void addToUseCaseList(UseCase useCase) {

		try{
			DataManager.useCaseList.add( useCase );
		}
		catch (NullPointerException e){
			DataManager.useCaseList = new ArrayList ();
			DataManager.useCaseList.add( useCase );
		}
	}
	
	/** adds one association to the main list of associations 
	 * @param actor object 
	 */		 
	static public void addToAssociationList(Association association) {

		try{
			DataManager.associationList.add( association );
		}
		catch (NullPointerException e){
			DataManager.associationList = new ArrayList ();
			DataManager.associationList.add( association );
		}
		
	}
	
	/** adds one dependency to the main list of dependencies 
	 * @param actor object 
	 */		 
	static public void addToDependencyList(Dependency dependency) {

		try{
			DataManager.dependencyList.add( dependency );
		}
		catch (NullPointerException e){
			DataManager.dependencyList = new ArrayList ();
			DataManager.dependencyList.add( dependency );
		}
	}

		 
	/************************************************************
	 * printing methods											*
	 ************************************************************/

	static public void printActors() {
		
		System.out.println("\nNumber of actors: " + Integer.toString(actorList.size()));
		for (int i= 0; i < actorList.size(); i++) {
			Actor actor = (Actor) actorList.get(i);
			actor.print();
		}
	}

	static public void printUseCases() {
		
		System.out.println("\nNumber of use cases: " + Integer.toString(useCaseList.size()));
		for (int i= 0; i < useCaseList.size(); i++) {
			UseCase useCase = (UseCase) useCaseList.get(i);
			useCase.print();
		}
	}
	
	static public void printDependencies() {
		
		System.out.println("\nNumber of dependencies: " + Integer.toString(dependencyList.size()));
		for (int i= 0; i < dependencyList.size(); i++) {
			Dependency dependency = (Dependency) dependencyList.get(i);
			dependency.print(dependency.getStereoType());
		}
	}
	
	static public void printAssociations() {
		
		System.out.println("\nNumber of Associations: " + Integer.toString(associationList.size()));
		for (int i= 0; i < associationList.size(); i++) {
			Association association = (Association) associationList.get(i);
			association.print();
		}
	}

	
	
	/************************************************************
	 * getter and setter methods								*
	 ************************************************************/
	
	

	/**
	 * @return Returns the actorList.
	 */
	public static ArrayList getActorList() {
		return actorList;
	}
	/**
	 * @param actorList The actorList to set.
	 */
	public static void setActorList(ArrayList actorList) {
		DataManager.actorList = actorList;
	}
	/**
	 * @return Returns the associationList.
	 */
	public static ArrayList getAssociationList() {
		return associationList;
	}
	/**
	 * @param associationList The associationList to set.
	 */
	public static void setAssociationList(ArrayList associationList) {
		DataManager.associationList = associationList;
	}
	/**
	 * @return Returns the dependencyList.
	 */
	public static ArrayList getDependencyList() {
		return dependencyList;
	}
	/**
	 * @param dependencyList The dependencyList to set.
	 */
	public static void setDependencyList(ArrayList dependencyList) {
		DataManager.dependencyList = dependencyList;
	}
	/**
	 * @return Returns the useCaseList.
	 */
	public static ArrayList getUseCaseList() {
		return useCaseList;
	}
	/**
	 * @param useCaseList The useCaseList to set.
	 */
	public static void setUseCaseList(ArrayList useCaseList) {
		DataManager.useCaseList = useCaseList;
	}
	
	/**
	 * @return Returns the extensionPointList.
	 */
	public static ArrayList getExtensionPointList() {
		return extensionPointList;
	}
	/**
	 * @param extensionPointList The extensionPointList to set.
	 */
	public static void setExtensionPointList(ArrayList extensionPointList) {
		DataManager.extensionPointList = extensionPointList;
	}
	
	/**
	 * @return Returns the generalizationList.
	 */
	public static ArrayList getGeneralizationList() {
		return generalizationList;
	}
	/**
	 * @param generalizationList The generalizationList to set.
	 */
	public static void setGeneralizationList(ArrayList generalizationList) {
		DataManager.generalizationList = generalizationList;
	}

	public static void clearAll() {
		actorList.clear();
		useCaseList.clear();
		dependencyList.clear();
		associationList.clear();
		extensionPointList.clear();
		generalizationList.clear();
		
	}
}
