package reucd.reverse;

import java.util.ArrayList;

public class DescriptionSkeletonWriter {
	
	public DescriptionSkeletonWriter (){
		
	}
	
	public void writeDescriptions(){
		ArrayList actorList = DataManager.getActorList();
		ArrayList useCaseList = DataManager.getUseCaseList();
		ArrayList generalizationList = DataManager.getGeneralizationList();
		ArrayList dependencyList = DataManager.getDependencyList();
		
		
		for (int i = 0 ; i < actorList.size(); i++){
			Actor currentActor = ((Actor)actorList.get(i));
			
			System.out.println("Actor:");
			if (currentActor.isAbstractActor()){
				System.out.println("ABSTRACT");
			}
			
			System.out.println(currentActor.getName());
			
			boolean isSpecializesPrinted = false;
			for (int j = 0 ; j < generalizationList.size(); j++){
				
				Generalization currentGeneralization = ((Generalization)generalizationList.get(j));
				
				if (!currentGeneralization.isChildUseCase()){
					Actor childActor = currentGeneralization.getChildActor();

					if (childActor.getActorId().equalsIgnoreCase(currentActor.getActorId())){
						
						if (!isSpecializesPrinted){
							System.out.print("SPECIALIZES");
							isSpecializesPrinted = true;
						}
						System.out.print(" "+ currentGeneralization.getParentActor().getName());
					}
					System.out.println("\n");
					
				}
			}
			
		}
		
		for (int i = 0 ; i < useCaseList.size(); i++){
			UseCase currentUseCase = ((UseCase)useCaseList.get(i));
			
			System.out.println("Use Case Name:");
			if (currentUseCase.isAbstractUsecase()){
				System.out.println("ABSTRACT");
			}
			
			System.out.println(currentUseCase.getName());
			
			boolean isSpecializesPrinted = false;
			for (int j = 0 ; j < generalizationList.size(); j++){
				
				Generalization currentGeneralization = ((Generalization)generalizationList.get(j));
				
				if (currentGeneralization.isChildUseCase()){
					UseCase childUseCase = currentGeneralization.getChildUseCase();
					
					
					
					if (childUseCase.getUseCaseId().equalsIgnoreCase(currentUseCase.getUseCaseId())){
						
						if (!isSpecializesPrinted){
							System.out.print("SPECIALIZES");
							isSpecializesPrinted = true;
						}
						System.out.print(" "+ currentGeneralization.getParentUseCase().getName());
					}
					System.out.println("\n");
					
				}
			}
			
			System.out.println("Basic Flow:\n");
			System.out.println("{ BEGIN Use Case }\n\n");
			System.out.println("{ END Use Case }\n\n");
			System.out.println("Alternative Flows:\n\n");
			System.out.println("Subflows:\n\n");
			System.out.println("Extension Points:\n\n");
			
			ArrayList useCaseEPs = currentUseCase.getExtensionPoints();
			for (int j = 0 ; j < useCaseEPs.size(); j++){
				ExtensionPoint currentExtensionPoint = ((ExtensionPoint)useCaseEPs.get(j));
				
				System.out.println("PUBLIC EXTENSION POINT");
				System.out.println(currentExtensionPoint.getName() + "\n");
			}
			
			for (int j = 0 ; j < dependencyList.size(); j++){
				Dependency currentDependency = ((Dependency)dependencyList.get(j));
				
				if ( currentDependency.getStereoType().equalsIgnoreCase("extend") &&
						currentDependency.getSupplierID().equalsIgnoreCase(currentUseCase.getUseCaseId())){
					
					String extendedUseCaseId = currentDependency.getClientID();
					String extendedUseCase = "";
					
					for (int k = 0 ; k < useCaseList.size(); k++){
						UseCase currentExtendedUseCase = ((UseCase)useCaseList.get(k));
						if (currentExtendedUseCase.getUseCaseId().equalsIgnoreCase(extendedUseCaseId)){
							extendedUseCase = currentExtendedUseCase.getName();
							k = useCaseList.size();//to exit the loop
						}
					}
					
					System.out.println("PUBLIC EXTENSION POINT BEHAVIOR");
					System.out.println("EXTENDING { " + extendedUseCase + " : " +  currentDependency.getExtensionPointName() + " }" );
					System.out.println("IF " + currentDependency.getCondition() + "\n\n");
					
				}
			}

			
		}
		
		System.out.println();
	}
	

}
