/**
 * Created on 2003-11-10
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package reucd.reverse;

import java.util.ArrayList;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


import reucd.reverse.*;
/**
 * @author Mohamed El-Attar
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */

/** This class implements the functionality of loading xml files.
 * */
public class XMLLoader {

	private String fileName = "";
	
	
	/** xml document */
	private Document doc = null;

	/**
	 * @param string xml filename
	 */
	public XMLLoader(String fileName) {	
		this.fileName = fileName;
	}

	public XMLLoader() {
	}
	
	public void loadXML() {
		
		try 
		{  
		
		  DOMParser parser = new DOMParser();	  
		  parser.parse(fileName);
		  doc = parser.getDocument();

		}
		catch (Exception e) 
		{	
		  System.err.println("XML reading error: " + e);
		}
	}
	

	/********************************************************** 
	 * creates 
	 **********************************************************/

	public void createUseCaseDiagramObjects() {
		
		loadXML();
		
		/** create lists of band and venue objects */
		createUseCaseDiagramObj(doc);
		
		completeDependencies();
		
		DataManager.printActors();
		DataManager.printUseCases();
		DataManager.printDependencies();
		DataManager.printAssociations();
		System.out.println();
	}


	/** traverses recursively the xml tree and creates use case diagram objects
	 * 	objects
	 * */
	private void createUseCaseDiagramObj(Node node) {
		
		int type = node.getNodeType();
		switch (type)
		{
			case Node.DOCUMENT_NODE: 
			{
				createUseCaseDiagramObj(((Document)node).getDocumentElement());
				break;
		    }
			
			/**  element with attributes */
			case Node.ELEMENT_NODE: 
			{
				
				
				
				if (node.getNodeName().equalsIgnoreCase("ownedMember")) {
					
					try{
						NamedNodeMap attrs = node.getAttributes(); 
						Node attr = null;
						
						for (int i = 0; i < attrs.getLength(); i++)
						{
							attr = attrs.item(i);
							if (attr.getNodeName().equalsIgnoreCase("type")) {
								break;
							} 
						}
						

						String attrType = attr.getNodeValue();
						
						if (attr.getNodeName().equalsIgnoreCase("xmi:type")) {

							if (attrType.equalsIgnoreCase("UML:Actor")) {
								Actor newActor = new Actor();
								createOneActor(node, newActor, "");
								/** add actor to the list */
								DataManager.addToActorList(newActor);		
							}
	
							if (attrType.equalsIgnoreCase("UML:UseCase")) {

								UseCase newUseCase = new UseCase();
								createOneUseCase(node, newUseCase, "");					
								/** add use case to the list */
								DataManager.addToUseCaseList(newUseCase);
							}				
							
							if (attrType.equalsIgnoreCase("UML:Association")) {
								
								Association newAssociation = new Association();
								createOneAssociation(node, newAssociation, "");	
								/** add association to the list */
								DataManager.addToAssociationList(newAssociation);
							}
							
							if (attrType.equalsIgnoreCase("UML:Include") &&
									!node.getParentNode().getNodeName().equalsIgnoreCase("UML:UseCase.include")) {
								
								Dependency newDependency = new Dependency();
								newDependency.setStereoType("include");
								createOneDependency(node, newDependency, "");
								/** add dependency to the list */
								DataManager.addToDependencyList(newDependency);
							}
						
						
							if (attr.getNodeName().equalsIgnoreCase("UML:Generalization")) {
								
								Generalization newGeneralization = new Generalization();
								createOneGeneralization(node, newGeneralization, "");	
								/** add association to the list */
								DataManager.addToGeneralizationList(newGeneralization);
							}
						}
						
					} catch (NullPointerException e){
						
					}

				}
				
				else if (node.getNodeName().equalsIgnoreCase("ownedEnd")) {//for associations
					
					Association association = (Association)DataManager.getAssociationList().get(DataManager.getAssociationList().size()-1);
					completeAssociation(node, association);	
					
				}
				
				else if (node.getNodeName().equalsIgnoreCase("include")) {
					
					UseCase lastUseCase= (UseCase)DataManager.getUseCaseList().get(DataManager.getUseCaseList().size()-1);
					
					Dependency newDependency = new Dependency();
					newDependency.setStereoType("include");
					newDependency.setClientUseCase(lastUseCase);
					
					NamedNodeMap attrs = node.getAttributes();


					for (int i = 0; i < attrs.getLength(); i++)
					{
						Node attr = attrs.item(i);
						if (attr.getNodeName().equalsIgnoreCase("addition")) {
							
							String additionUseCaseId = attr.getNodeValue();
							newDependency.setSupplierID(additionUseCaseId);
						
							
						} 
						else if (attr.getNodeName().equalsIgnoreCase("xmi:id")) {
							String dependencyId = attr.getNodeValue();
							newDependency.setDependencyId(dependencyId);
						}
						
					}
					
					DataManager.getDependencyList().add(newDependency);
					
				}
				
				else if (node.getNodeName().equalsIgnoreCase("specification")) {//for conditions
					NamedNodeMap attrs = node.getAttributes();

					for (int i = 0; i < attrs.getLength(); i++)
					{
						Node attr = attrs.item(i);
						if (attr.getNodeName().equalsIgnoreCase("body")) {
							
							String condition = attr.getNodeValue();
							//System.out.println("our condition: " + condition);
							Dependency lastDependency = ((Dependency)DataManager.getDependencyList().get(DataManager.getDependencyList().size()-1));
							lastDependency.setCondition(condition);
						} 
						
					}
					
				}
				else if (node.getNodeName().equalsIgnoreCase("generalization")) {
					
					UseCase lastUseCase= (UseCase)DataManager.getUseCaseList().get(DataManager.getUseCaseList().size()-1);
					Actor lastActor= (Actor)DataManager.getActorList().get(DataManager.getActorList().size()-1);
					
					String childType = "";
					Node lastNode = node.getParentNode();
					
					NamedNodeMap lastAttrs = lastNode.getAttributes();
					
					for (int i = 0; i < lastAttrs.getLength(); i++){
						Node attr = lastAttrs.item(i);
						if (attr.getNodeName().equalsIgnoreCase("xmi:type")) {
							
							childType = attr.getNodeValue();

						} 
						
					}

					Generalization newGeneralization = new Generalization();
					
					
					

					if (childType.equalsIgnoreCase("uml:UseCase")){
						newGeneralization.setIsChildUseCase(true);
						newGeneralization.setChildUseCase(lastUseCase);
						
						NamedNodeMap attrs = node.getAttributes();
						
						for (int i = 0; i < attrs.getLength(); i++){
							Node attr = attrs.item(i);
							if (attr.getNodeName().equalsIgnoreCase("general")) {
								
								String parentUseCaseId = attr.getNodeValue();
								ArrayList useCaseList = ((ArrayList)DataManager.getUseCaseList());
								for (int j = 0 ; j < useCaseList.size(); j++){
									UseCase currentUseCase = ((UseCase)useCaseList.get(j));
									if (currentUseCase.getUseCaseId().equalsIgnoreCase(parentUseCaseId)){
										newGeneralization.setParentUseCase(currentUseCase);
										newGeneralization.setIsParentUseCase(true);
									}
								}

							} 
							
							
						}
						
					}
					
					if (childType.equalsIgnoreCase("uml:Actor")){
						newGeneralization.setIsChildUseCase(false);
						newGeneralization.setChildActor(lastActor);
						
						NamedNodeMap attrs = node.getAttributes();
						
						for (int i = 0; i < attrs.getLength(); i++){
							Node attr = attrs.item(i);
							if (attr.getNodeName().equalsIgnoreCase("general")) {
								
								String parentActorId = attr.getNodeValue();
								ArrayList actorList = ((ArrayList)DataManager.getActorList());
								for (int j = 0 ; j < actorList.size(); j++){
									Actor currentActor= ((Actor)actorList.get(j));
									if (currentActor.getActorId().equalsIgnoreCase(parentActorId)){
										newGeneralization.setParentActor(currentActor);
										newGeneralization.setIsParentUseCase(false);
									}
								}

							} 
							
							
						}
						
					}
					
					DataManager.addToGeneralizationList(newGeneralization);
					
				}
				
				else if (node.getNodeName().equalsIgnoreCase("extensionPoint")) {
					
					UseCase lastUseCase= (UseCase)DataManager.getUseCaseList().get(DataManager.getUseCaseList().size()-1);
				
					ExtensionPoint extensionPoint = new ExtensionPoint();
					
					
					NamedNodeMap attrs = node.getAttributes();
					


					for (int i = 0; i < attrs.getLength(); i++)
					{
						Node attr = attrs.item(i);
						if (attr.getNodeName().equalsIgnoreCase("name")) {
							
							String extensionPointName = attr.getNodeValue();						
							extensionPoint.setName(extensionPointName);
						} 
						else if (attr.getNodeName().equalsIgnoreCase("xmi:id")) {
							String extensionLocationId = attr.getNodeValue();
							extensionPoint.setExtensionPointId(extensionLocationId);
						}
						else if (attr.getNodeName().equalsIgnoreCase("extension")) {
							String supplierId = attr.getNodeValue();
							extensionPoint.setExtensionID(supplierId);
						}
						
					}
					
					lastUseCase.getExtensionPoints().add(extensionPoint);

					
				}
				
				else if (node.getNodeName().equalsIgnoreCase("extend")) {
					
					UseCase lastUseCase= (UseCase)DataManager.getUseCaseList().get(DataManager.getUseCaseList().size()-1);
					
					Dependency newDependency = new Dependency();
					newDependency.setStereoType("extend");
					newDependency.setSupplierUseCase(lastUseCase);
					newDependency.setSupplierID(lastUseCase.getUseCaseId());
					
					
					NamedNodeMap attrs = node.getAttributes();
					


					for (int i = 0; i < attrs.getLength(); i++)
					{
						Node attr = attrs.item(i);
						if (attr.getNodeName().equalsIgnoreCase("xmi:id")) {
							String dependencyId = attr.getNodeValue();
							newDependency.setDependencyId(dependencyId); //this is the extension Id
						}
						else if (attr.getNodeName().equalsIgnoreCase("extendedCase")) {
							String clientId = attr.getNodeValue();
							newDependency.setClientID(clientId);
						}
						else if (attr.getNodeName().equalsIgnoreCase("extensionLocation")) {
							String extensionLocationId = attr.getNodeValue();
							newDependency.setExtenstionLocationId(extensionLocationId);
						}
						
					}
					
					DataManager.getDependencyList().add(newDependency);
					
				}
				
				NodeList children = node.getChildNodes();
				
				if (children != null)
				{
					int len = children.getLength();
					for (int i = 0; i < len; i++)
						createUseCaseDiagramObj(children.item(i));
				}
				
				break;
				
			}			
		}
		
		
	}

	
	

	private void completeDependencies() {
		ArrayList dependenciesList = (ArrayList)DataManager.getDependencyList();
		
		for (int i = 0 ; i <dependenciesList.size() ; i++){
			
			Dependency currentDependency = (Dependency)dependenciesList.get(i);
			
			if (currentDependency.getStereoType().equalsIgnoreCase("include")){
				
				ArrayList useCaseList = (ArrayList)DataManager.getUseCaseList();
				for (int j = 0 ; j <  useCaseList.size(); j++){
					
					UseCase currentUseCase = ((UseCase)useCaseList.get(j)); 
					if (currentUseCase.getUseCaseId().equalsIgnoreCase(currentDependency.getSupplierID())){
						
						currentDependency.setSupplierUseCase(currentUseCase);
						
					}
				}
				
			}
		}
		
		for (int i = 0 ; i <dependenciesList.size() ; i++){
			
			Dependency currentDependency = (Dependency)dependenciesList.get(i);
			
			if (currentDependency.getStereoType().equalsIgnoreCase("extend")){

				ArrayList useCaseList = (ArrayList)DataManager.getUseCaseList();
				for (int j = 0 ; j <  useCaseList.size(); j++){
					
					UseCase currentUseCase = ((UseCase)useCaseList.get(j)); 
					
					if (currentUseCase.getUseCaseId().equalsIgnoreCase(currentDependency.getClientID())){
						currentDependency.setClientUseCase(currentUseCase);
						currentDependency.setClientID(currentUseCase.getUseCaseId());
						
						ArrayList extensionPointsList = (ArrayList)currentUseCase.getExtensionPoints();
						
						for (int k = 0; k < extensionPointsList.size() ; k++){
							
							ExtensionPoint currentExtensionPoint = ((ExtensionPoint)extensionPointsList.get(k));
							
							if (currentExtensionPoint.getExtensionPointId().equalsIgnoreCase(currentDependency.getExtenstionLocationId())
									&& currentExtensionPoint.getExtensionID().equalsIgnoreCase(currentDependency.getDependencyId())) {
								currentDependency.setExtensionPointName(currentExtensionPoint.getName());
							}
							
						}
						
					}
					
				}
				
			}
		}
	}

	/** fills with data one actor object 
	 * param String lastNodeName: is necessary to preserve the name of the last
	 * visited node 
	 * */
	private void createOneActor(Node node, Actor newActor, String lastNodeName) {

		int type = node.getNodeType();
		switch (type)
		{
			/**  element with attributes */
			case Node.ELEMENT_NODE: 
			{
				NamedNodeMap attrs = node.getAttributes();

				for (int i = 0; i < attrs.getLength(); i++)
				{
					Node attr = attrs.item(i);
					if ((node.getNodeName().equalsIgnoreCase("ownedMember"))&&
						(attr.getNodeName().equalsIgnoreCase("xmi:id"))) {
						
						String actorId = attr.getNodeValue();
						newActor.setActorId(actorId);
					} 
					
					if ((node.getNodeName().equalsIgnoreCase("ownedMember"))&&
							(attr.getNodeName().equalsIgnoreCase("name"))) {
							
							String actorName = attr.getNodeValue();
							newActor.setName(actorName);
					} 
					
					if ((node.getNodeName().equalsIgnoreCase("ownedMember"))&&
							(attr.getNodeName().equalsIgnoreCase("isAbstract"))) {
								
							
							String isAbstract = attr.getNodeValue();
							if (isAbstract.equalsIgnoreCase("true")){
								newActor.setAbstractActor(true);
							}
							
					} 
				}					
				break;
			}

		} /** end switch */		

	}

	/**
	 * fills with data one venue object 
	 * param String lastNodeName: is necessary to preserve the name of the last
	 * visited node 
	 * */
	private void createOneUseCase(Node node, UseCase newUseCase, String lastNodeName) {

		int type = node.getNodeType();
		switch (type)
		{
			/**  element with attributes */
			case Node.ELEMENT_NODE: 
			{
				NamedNodeMap attrs = node.getAttributes();

				for (int i = 0; i < attrs.getLength(); i++)
				{
					Node attr = attrs.item(i);
					if ((node.getNodeName().equalsIgnoreCase("ownedMember"))&&
							(attr.getNodeName().equalsIgnoreCase("xmi:id"))) {
							
							String useCaseId = attr.getNodeValue();
							newUseCase.setUseCaseId(useCaseId);
					} 
						
					if ((node.getNodeName().equalsIgnoreCase("ownedMember"))&&
							(attr.getNodeName().equalsIgnoreCase("name"))) {
						
							String useCaseName = attr.getNodeValue();
							newUseCase.setName(useCaseName);
					} 
					
					if ((node.getNodeName().equalsIgnoreCase("ownedMember"))&&
							(attr.getNodeName().equalsIgnoreCase("isAbstract"))) {
								
							
							String isAbstract = attr.getNodeValue();
							if (isAbstract.equalsIgnoreCase("true")){
								newUseCase.setAbstractUsecase(true);
							}
							
					} 
				}
								
				break;
			}
					
		} /** end switch */		


	}

	/** fills with data one association object 
	 * param String lastNodeName: is necessary to preserve the name of the last
	 * visited node 
	 * */
	private void createOneAssociation(Node node, Association newAssociation, String lastNodeName) {

		int type = node.getNodeType();
		
		switch (type)
		{
			/**  element with attributes */
			case Node.ELEMENT_NODE: 
			{
				NamedNodeMap attrs = node.getAttributes();

				for (int i = 0; i < attrs.getLength(); i++)
				{
					Node attr = attrs.item(i);
					if ((node.getNodeName().equalsIgnoreCase("ownedMember"))&&
						(attr.getNodeName().equalsIgnoreCase("xmi:id"))) {
						
						String associationId = attr.getNodeValue();
						newAssociation.setAssociationId(associationId);
						
					}  
					
				}
		
				
			}	
			break;

		} /** end switch */		
		
		
	}
	
	private void completeAssociation(Node node, Association association) {
		
		NamedNodeMap attrs = node.getAttributes();


		for (int i = 0; i < attrs.getLength(); i++)
		{
			Node attr = attrs.item(i);
			if ((node.getNodeName().equalsIgnoreCase("ownedEnd"))&&
				(attr.getNodeName().equalsIgnoreCase("type"))) {
				
				String endId = attr.getNodeValue();
				
				for (int j = 0; j < DataManager.getActorList().size(); j++)
				{
					if (endId.equalsIgnoreCase( ((Actor) ( (DataManager.getActorList()).get(j)) ).getActorId())) {  
						association.setActorEnd((Actor)( (DataManager.getActorList()).get(j)) );
					}
				}
				
				for (int j = 0; j < DataManager.getUseCaseList().size(); j++)
				{
					if (endId.equalsIgnoreCase(((UseCase)( (DataManager.getUseCaseList()).get(j)) ).getUseCaseId())){  
						association.setUseCaseEnd((UseCase)( (DataManager.getUseCaseList()).get(j)) );
					}
				}

				
			}  
			
		}

		
		
	}
	
	/** fills with data one dependency object 
	 * param String lastNodeName: is necessary to preserve the name of the last
	 * visited node 
	 * */
	private void createOneDependency(Node node, Dependency newDependency, String lastNodeName) {

		int type = node.getNodeType();

		switch (type)
		{
			/**  element with attributes */
			case Node.ELEMENT_NODE: 
			{
				NamedNodeMap attrs = node.getAttributes();

				for (int i = 0; i < attrs.getLength(); i++)
				{
					Node attr = attrs.item(i);
					if ((node.getNodeName().equalsIgnoreCase("include"))&&
						(attr.getNodeName().equalsIgnoreCase("addition"))){
																	
						String includedId = attr.getNodeValue();
						for (int j = 0 ; j < DataManager.getUseCaseList().size() ; j++){
							if (includedId.equalsIgnoreCase(((UseCase)( (DataManager.getUseCaseList()).get(j))).getUseCaseId())){
								newDependency.setClientUseCase(((UseCase)( (DataManager.getUseCaseList()).get(j))));
								break;
							}
						}
					} 
					else if ((node.getNodeName().equalsIgnoreCase("include"))&&
							(attr.getNodeName().equalsIgnoreCase("base"))){
						
						String baseId = attr.getNodeValue();
						for (int j = 0 ; j < DataManager.getUseCaseList().size() ; j++){
							if (baseId.equalsIgnoreCase(((UseCase)( (DataManager.getUseCaseList()).get(j))).getUseCaseId())){
								newDependency.setSupplierUseCase(((UseCase)( (DataManager.getUseCaseList()).get(j))));
								break;
							}
						}
			
					}
					else if ((node.getNodeName().equalsIgnoreCase("UML:Extend"))&&
							(attr.getNodeName().equalsIgnoreCase("extension"))){
						
						String extendedId = attr.getNodeValue();
						for (int j = 0 ; j < DataManager.getUseCaseList().size() ; j++){
							if (extendedId.equalsIgnoreCase(((UseCase)( (DataManager.getUseCaseList()).get(j))).getUseCaseId())){
								newDependency.setClientUseCase(((UseCase)( (DataManager.getUseCaseList()).get(j))));
								break;
							}
						}
					}
					else if ((node.getNodeName().equalsIgnoreCase("UML:Extend"))&&
							(attr.getNodeName().equalsIgnoreCase("base"))){
						
						String baseId = attr.getNodeValue();
						for (int j = 0 ; j < DataManager.getUseCaseList().size() ; j++){
							if (baseId.equalsIgnoreCase(((UseCase)( (DataManager.getUseCaseList()).get(j))).getUseCaseId())){
								newDependency.setSupplierUseCase(((UseCase)( (DataManager.getUseCaseList()).get(j))));
								break;
							}
						}	
					}
					
				}
			}		/**end case*/
		} /**end swithch*/		
	}
	
	/** fills with data one actor object 
	 * param String lastNodeName: is necessary to preserve the name of the last
	 * visited node 
	 * */
	private void createOneExtensionPoint(Node node, ExtensionPoint newExtensionPoint, String lastNodeName) {

		int type = node.getNodeType();
		
		switch (type)
		{
			/**  element with attributes */
			case Node.ELEMENT_NODE: 
			{
				NamedNodeMap attrs = node.getAttributes();

				for (int i = 0; i < attrs.getLength(); i++)
				{
					Node attr = attrs.item(i);
					if ((node.getNodeName().equalsIgnoreCase("UML:ExtensionPoint"))&&
							(attr.getNodeName().equalsIgnoreCase("xmi:id"))) {
						
						String extensionPointId = attr.getNodeValue();
						newExtensionPoint.setExtensionPointId(extensionPointId);
					} 
					
					if ((node.getNodeName().equalsIgnoreCase("UML:ExtensionPoint"))&&
							(attr.getNodeName().equalsIgnoreCase("name"))) {
						
						String extensionPointName = attr.getNodeValue();
						newExtensionPoint.setName(extensionPointName);
					} 
				}					
				break;
			}

		} /** end switch */		

	}
	
	/** fills with data one actor object 
	 * param String lastNodeName: is necessary to preserve the name of the last
	 * visited node 
	 * */
	private void createOneGeneralization(Node node, Generalization newGeneralization, String lastNodeName) {

		int type = node.getNodeType();
		
		switch (type)
		{
			/**  element with attributes */
			case Node.ELEMENT_NODE: 
			{
				NamedNodeMap attrs = node.getAttributes();

				for (int i = 0; i < attrs.getLength(); i++)
				{
					Node attr = attrs.item(i);
					if ((node.getNodeName().equalsIgnoreCase("UML:Generalization"))&&
							(attr.getNodeName().equalsIgnoreCase("parent"))) {
						
						String parentId = attr.getNodeValue();
						boolean parentIsUseCase = false;
						for (int j = 0 ; j < DataManager.getUseCaseList().size() && !parentIsUseCase;j++){
							if (parentId.equalsIgnoreCase(((UseCase)(DataManager.getUseCaseList().get(j))).getUseCaseId())){
								newGeneralization.setParentUseCase((UseCase)(DataManager.getUseCaseList().get(j)));
								parentIsUseCase = true;
							}
						}
						
						for (int j = 0 ; j < DataManager.getActorList().size() && !parentIsUseCase;j++){
							if (parentId.equalsIgnoreCase(((Actor)(DataManager.getActorList().get(j))).getActorId())){
								newGeneralization.setParentActor((Actor)(DataManager.getActorList().get(j)));
							}
						}
						
						newGeneralization.setIsParentUseCase(parentIsUseCase);
					} 
					
					if ((node.getNodeName().equalsIgnoreCase("UML:Generalization"))&&
							(attr.getNodeName().equalsIgnoreCase("child"))) {
						
						String childId = attr.getNodeValue();
						boolean childIsUseCase = false;
						for (int j = 0 ; j < DataManager.getUseCaseList().size() && !childIsUseCase;j++){
							if (childId.equalsIgnoreCase(((UseCase)(DataManager.getUseCaseList().get(j))).getUseCaseId())){
								newGeneralization.setChildUseCase((UseCase)(DataManager.getUseCaseList().get(j)));
								childIsUseCase = true;
							}
						}
						
						for (int j = 0 ; j < DataManager.getActorList().size() && !childIsUseCase;j++){
							if (childId.equalsIgnoreCase(((Actor)(DataManager.getActorList().get(j))).getActorId())){
								newGeneralization.setChildActor((Actor)(DataManager.getActorList().get(j)));
							}
						}
						
						newGeneralization.setIsChildUseCase(childIsUseCase);
					} 
				}					
				break;
			}

		} /** end switch */		

	}
	
	private String retrieveExtensionPointId (Node node){
		int type = node.getNodeType();
		String extensionPointId = "";

		switch (type)
		{
			/**  element with attributes */
			case Node.ELEMENT_NODE: 
			{
				NamedNodeMap attrs = node.getAttributes();

				for (int i = 0; i < attrs.getLength(); i++)
				{
					Node attr = attrs.item(i);
					if ((node.getNodeName().equalsIgnoreCase("UML:ExtensionPoint"))&&
							(attr.getNodeName().equalsIgnoreCase("xmi:idref"))) {
						
						extensionPointId = attr.getNodeValue();
						return extensionPointId;
					} 	
				}					
				break;
			}

		} /** end switch */	
		return extensionPointId;
	}
	
}